Syncfusion AI Assistant

How can I help you?

Drag and drop in EJ2 JavaScript Kanban control

23 Jun 202324 minutes to read

All cards can be dragged and dropped across the columns or within the columns or swimlane row or kanban to an external source and vice versa.

The following drag and drop types are available in the Kanban board.

  • Internal drag and drop
    • Column drag and drop
    • Swimlane drag and drop
  • External drag and drop
    • Kanban to Kanban
    • Kanban to External source and vice versa.

Dropped card position varies based on the sortSettings property.

Internal drag and drop

Allows the user to drag and drop the cards within the kanban board. Based on this, we can categorize into two ways.

  • Column drag and drop
  • Swimlane drag and drop

Column drag and drop

By default, all cards can be dragged and dropped across the columns and within the columns. You cannot drag and drop the cards when disabling the allowDragAndDrop property.

You can prevent the drag or drop behavior of the particular column by disabling the allowDrag or allowDrop property.
You can also control the flow of transition cards between the columns by using the transitionColumns property.

In the following example, disable the drag and drop behavior on the Kanban board.

var kanbanObj = new ej.kanban.Kanban({
    dataSource: kanbanData,
    keyField: 'Status',
    columns: [
        { headerText: 'Backlog', keyField: 'Open' },
        { headerText: 'In Progress', keyField: 'InProgress' },
        { headerText: 'Testing', keyField: 'Testing' },
        { headerText: 'Done', keyField: 'Close' }
    ],
    cardSettings: {
        contentField: 'Summary',
        headerField: 'Id'
    },
    allowDragAndDrop: false
});
kanbanObj.appendTo('#Kanban');
<!DOCTYPE html><html lang="en"><head>
    <title>Across Swimlane Drag and Drop</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Swimlane drag and drop">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-inputs/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-layouts/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-kanban/styles/tailwind3.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div class="content-wrapper">
            <div id="Kanban"></div>
        </div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Swimlane drag and drop

By default, Swimlane allows drag and drop across the columns within the swimlane row. Kanban does not allow dragging the cards across the swimlane rows.

Enabling the dragAndDrop property allows you to drag the cards across the swimlane rows, which is specified inside the swimlaneSettings property.

var kanbanObj = new ej.kanban.Kanban({
    dataSource: kanbanData,
    keyField: 'Status',
    columns: [
        { headerText: 'Backlog', keyField: 'Open' },
        { headerText: 'In Progress', keyField: 'InProgress' },
        { headerText: 'Testing', keyField: 'Testing' },
        { headerText: 'Done', keyField: 'Close' }
    ],
    cardSettings: {
        contentField: 'Summary',
        headerField: 'Id'
    },
    swimlaneSettings: {
        keyField: 'Assignee',
        allowDragAndDrop: true
    }
});
kanbanObj.appendTo('#Kanban');
<!DOCTYPE html><html lang="en"><head>
    <title>Across Swimlane Drag and Drop</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Swimlane drag and drop">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-inputs/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-layouts/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-kanban/styles/tailwind3.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div class="content-wrapper">
            <div id="Kanban"></div>
        </div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

External drag and drop

Allows the user to drag and drop the cards from one kanban to another kanban or Kanban to an external source and vice versa.

Kanban to kanban

Drag and drop the card from one kanban to another kanban and vice versa. This can be achieved by specifying the externalDropId property which is used to specify the id of the dropped kanban element and the dragStop event which is used to delete the card on dragged Kanban and add the card on dropped Kanban using the deleteCard and addCard public methods.

Before adding a card to dropped kanban, you can manually change the card data headerField when the same card data headerField is dropped to another Kanban.

In the following example, Drag the card from one Kanban and drop it into another kanban using the dragStop event. In this event, remove the card from the dragged Kanban by using the deleteCard public method and add the card to the dropped Kanban by using the addCard public method.

var kanbanOptionsA = {
    dataSource: kanbanAData,
    keyField: 'Status',
    columns: [
        { headerText: 'Backlog', keyField: 'Open' },
        { headerText: 'Done', keyField: 'Close' }
    ],
    externalDropId: ['#kanbanB'],
    cardSettings: {
        contentField: 'Summary',
        headerField: 'Id'
    },
    showEmptyColumn: true,
    dragStop: function (args) {
        if (ej.base.closest(args.event.target, '#kanbanB')) {
            kanbanObjA.deleteCard(args.data);
            args.data.forEach(function (card, i) {
                var index = kanbanObjB.kanbanData.findIndex(function (colData) {
                    return colData[kanbanObjB.cardSettings.headerField] === card[kanbanObjB.cardSettings.headerField];
                });
                if (index !== -1) {
                    card[kanbanObjB.cardSettings.headerField] = Math.max.apply(Math, kanbanObjB.kanbanData.map(function (obj) { return parseInt(obj[kanbanObjB.cardSettings.headerField], 10); })) + ++i;
                }
            });
            kanbanObjB.addCard(args.data, args.dropIndex);
            args.cancel = true;
        }
    }
};
var kanbanObjA = new ej.kanban.Kanban(kanbanOptionsA);
kanbanObjA.appendTo('#kanbanA');
var kanbanOptionsB = {
    dataSource: kanbanBData,
    keyField: 'Status',
    columns: [
        { headerText: 'Backlog', keyField: 'Open' },
        { headerText: 'Done', keyField: 'Close' }
    ],
    cardSettings: {
        contentField: 'Summary',
        headerField: 'Id'
    },
    externalDropId: ['#kanbanA'],
    showEmptyColumn: true,
    dragStop: function (args) {
        if (ej.base.closest(args.event.target, '#kanbanA')) {
            kanbanObjB.deleteCard(args.data);
            args.data.forEach(function (card, i) {
                var index = kanbanObjA.kanbanData.findIndex(function (colData) {
                    return colData[kanbanObjA.cardSettings.headerField] === card[kanbanObjA.cardSettings.headerField];
                });
                if (index !== -1) {
                    card[kanbanObjA.cardSettings.headerField] = Math.max.apply(Math, kanbanObjA.kanbanData.map(function (obj) { return parseInt(obj[kanbanObjA.cardSettings.headerField], 10); })) + ++i;
                }
            });
            kanbanObjA.addCard(args.data, args.dropIndex);
            args.cancel = true;
        }
    }
};
var kanbanObjB = new ej.kanban.Kanban(kanbanOptionsB);
kanbanObjB.appendTo('#kanbanB');
<!DOCTYPE html><html lang="en"><head>
    <title>Kanban to Kanban Drag and Drop</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Kanban to Kanban drag and drop">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-inputs/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-layouts/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-kanban/styles/tailwind3.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div class="container-fluid">
            <div class="row">
                <div class="col-sm-6">
                    <h4>Kanban A</h4>
                    <div id="kanbanA"></div>
                </div>
                <div class="col-sm-6">
                    <h4>Kanban B</h4>
                    <div id="kanbanB"></div>
                </div>
            </div>
        </div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Treeview to Kanban

Drag the card from the Kanban board and drop it to the Treeview component and vice versa.

In the following sample, remove the data from the Kanban board using the deleteCard public method and add to the Treeview component using the addNodes public method at Kanban dragStop event when dragging the card and dropping it to the Treeview component. Remove the data from Treeview using the removeNodes public method and add to Kanban board using the openDialog public method when dragging the list from the Treeview component and dropping it to the kanban board.

var kanbanOptions = {
        dataSource: kanbanData,
        keyField: 'Status',
        columns: [
            { headerText: 'Backlog', keyField: 'Open' },
            { headerText: 'Done', keyField: 'Close' }
        ],
        externalDropId: ['#TreeView'],
        cardSettings: {
            contentField: 'Summary',
            headerField: 'Id'
        },
        showEmptyColumn: true,
        dragStop: function (args) {
            if (ej.base.closest(args.event.target, '#TreeView')) {
                kanbanObj.deleteCard(args.data);
                treeObj.addNodes(args.data);
                args.cancel = true;
            }
        }
    };
    var kanbanObj = new ej.kanban.Kanban(kanbanOptions);
    kanbanObj.appendTo('#Kanban');
    var treeObj = new ej.navigations.TreeView({
        fields: { dataSource: treeViewData, id: 'Id', text: 'Status' },
        allowDragAndDrop: true,
        nodeDragStop: onTreeDragStop,
        nodeTemplate: '#treeTemplate'
    });
    treeObj.appendTo('#TreeView');
    function onTreeDragStop(args) {
        if (ej.base.closest(args.event.target, '#Kanban')) {
            var treeData = treeObj.fields.dataSource;
            var filteredData = treeData.filter(function (item) { return item.Id === parseInt(args.draggedNodeData.id, 10); });
            treeObj.removeNodes([args.draggedNodeData.id]);
            kanbanObj.openDialog('Add', filteredData[0]);
            args.cancel = true;
        }
    }
<!DOCTYPE html><html lang="en"><head>
    <title>Kanban to TreeView Drag and Drop</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Kanban to TreeView drag and drop">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/tailwind3.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    
        <div id="container">
            <div class="container-fluid">
                <div class="row">
                    <div class="col-sm-6">
                    <h4>Kanban</h4>
                    <div id="Kanban"></div>
                </div>
                <div class="col-sm-6">
                    <h4>TreeView</h4>
                    <div id="TreeView" style="border: 1px solid #e0e0e0"></div>
                </div>
            </div>
        </div>
    </div>
    <script id="treeTemplate" type="text/x-template">
        <div id="treelist">
            <div id="treeviewlist">${Id} - ${Status}</div>
        </div>
    </script>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Schedule to Kanban

Drag the card from the Kanban board and drop it to the Schedule component and vice versa.

In the following sample, remove the data from the Kanban board using the deleteCard public method and add to the schedule component using the addNodes public method at Kanban dragStop event when dragging the card and dropping it to the Treeview component. Remove the data from Treeview using the removeNodes public method and add to Kanban board using the addCard public method when dragging the list from the Treeview component and dropping it to the kanban board.

var kanbanOptions = {
        dataSource: kanbanData,
        keyField: 'DepartmentName',
        columns: [
            { headerText: 'GENERAL', keyField: 'GENERAL' }
        ],
        externalDropId: ['#Schedule'],
        cardSettings: {
            contentField: 'Name',
            headerField: 'Id',
            selectionType: 'Multiple'
        },
        showEmptyColumn: true,
        dragStop: function (args) {
            if (ej.base.closest(args.event.target, '#Schedule')) {
                kanbanObj.deleteCard(args.data);
                scheduleObj.openEditor(args.data[0], 'Add', true);
                args.cancel = true;
            }
        }
    };
    var kanbanObj = new ej.kanban.Kanban(kanbanOptions);
    kanbanObj.appendTo('#Kanban');
    ej.schedule.Schedule.Inject(ej.schedule.TimelineViews, ej.schedule.TimelineMonth, ej.schedule.Resize, ej.schedule.DragAndDrop);
    var scheduleObj = new ej.schedule.Schedule({
        width: '100%',
        height: '650px',
        selectedDate: new Date(2018, 7, 1),
        currentView: 'TimelineDay',
        eventDragArea: "body",
        cssClass: 'schedule-drag-drop',
        workHours: {
            start: '08:00',
            end: '18:00'
        },
        views: [
            { option: 'TimelineDay' },
            { option: 'TimelineMonth' }
        ],
        group: {
            enableCompactView: false,
            resources: ['Departments', 'Consultants']
        },
        resources: [
            {
                field: 'DepartmentID', title: 'Department',
                name: 'Departments', allowMultiple: false,
                dataSource: [
                    { Text: 'GENERAL', Id: 1, Color: '#bbdc00' },
                    { Text: 'DENTAL', Id: 2, Color: '#9e5fff' }
                ],
                textField: 'Text', idField: 'Id', colorField: 'Color'
            },
            {
                field: 'ConsultantID', title: 'Consultant',
                name: 'Consultants', allowMultiple: false,
                dataSource: [
                    { Text: 'Alice', Id: 1, GroupId: 1, Color: '#bbdc00', Designation: 'Cardiologist' },
                    { Text: 'Nancy', Id: 2, GroupId: 2, Color: '#9e5fff', Designation: 'Orthodontist' },
                    { Text: 'Robert', Id: 3, GroupId: 1, Color: '#bbdc00', Designation: 'Optometrist' },
                    { Text: 'Robson', Id: 4, GroupId: 2, Color: '#9e5fff', Designation: 'Periodontist' },
                    { Text: 'Laura', Id: 5, GroupId: 1, Color: '#bbdc00', Designation: 'Orthopedic' },
                    { Text: 'Margaret', Id: 6, GroupId: 2, Color: '#9e5fff', Designation: 'Endodontist' }
                ],
                textField: 'Text', idField: 'Id', groupIDField: 'GroupId', colorField: 'Color'
            }
        ],
        eventSettings: {
            dataSource: scheduleData,
            fields: {
                subject: { title: 'Patient Name', name: 'Name' },
                startTime: { title: 'From', name: 'StartTime' },
                endTime: { title: 'To', name: 'EndTime' },
                description: { title: 'Reason', name: 'Description' }
            }
        },
        dragStop: scheduleDragStop
    });
    scheduleObj.appendTo('#Schedule');
    function scheduleDragStop(args) {
        if (ej.base.closest(args.event.target, '#Kanban')) {
            scheduleObj.deleteEvent(args.data.Id);
            ej.base.removeClass([scheduleObj.element.querySelector('.e-selected-cell')], 'e-selected-cell');
            kanbanObj.openDialog('Add', args.data);
            args.cancel = true;
        }
    }
<!DOCTYPE html><html lang="en"><head>
    <title>Kanban to Schedule Drag and Drop</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Kanban to Schedule drag and drop">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/tailwind3.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div class="container-fluid">
            <div class="row">
                <div class="col-sm-6">
                    <h4>Kanban</h4>
                    <div id="Kanban"></div>
                </div>
                <div class="col-sm-6">
                    <h4>Schedule</h4>
                    <div id="Schedule"></div>
                </div>
            </div>
        </div>
    </div>
    <script id="resource-template" type="text/x-template">
        <div class="template-wrap">
            <div class="specialist-category"> 
                ${getConsultantImage(data)}
                <div class="specialist-name">${getConsultantName(data)}</div>
                <div class="specialist-designation">${getConsultantDesignation(data)}</div>
            </div>
        </div>
    </script>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Syncfusion AI Assistant

How can I help you?

Drag and Drop in Angular Kanban Component

2 Sep 202524 minutes to read

All cards can be dragged and dropped across the columns or within the columns or swimlane row or kanban to an external source and vice versa.

The following drag and drop types are available in the Kanban board.

  • Internal drag and drop
    • Column drag and drop
    • Swimlane drag and drop
  • External drag and drop
    • Kanban to Kanban
    • Kanban to External source and vice versa.

Dropped card position varies based on the sortSettings property.

Internal drag and drop

Allows the user to drag and drop the cards within the kanban board. Based on this, we can categorize into two ways.

  • Column drag and drop
  • Swimlane drag and drop

Column drag and drop

By default, all cards can be dragged and dropped across the columns and within the columns. You cannot drag and drop the cards when disabling the allowDragAndDrop property.

You can prevent the drag or drop behavior of the particular column by disabling the allowDrag or allowDrop property.
You can also control the flow of transition cards between the columns by using the transitionColumns property.

In the following example, disable the drag and drop behavior on the Kanban board.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { KanbanModule } from '@syncfusion/ej2-angular-kanban'
import { Component } from '@angular/core';
import { CardSettingsModel } from '@syncfusion/ej2-angular-kanban';
import { kanbanData } from './datasource';

@Component({
    imports: [
        KanbanModule
    ],
    standalone: true,
    selector: 'app-root',
    template: `<ejs-kanban keyField='Status' [dataSource]='data' [cardSettings]='cardSettings' [allowDragAndDrop]='allowDragAndDrop'>
                <e-columns>
                  <e-column headerText='To do' keyField='Open'></e-column>
                  <e-column headerText='In Progress' keyField='InProgress'></e-column>
                  <e-column headerText='Testing' keyField='Testing'></e-column>
                  <e-column headerText='Done' keyField='Close'></e-column>
                </e-columns>
            </ejs-kanban>`
})
export class AppComponent {
    public data: Object[] = kanbanData;
    public allowDragAndDrop: Boolean = false;
    public cardSettings: CardSettingsModel = {
        contentField: 'Summary',
        headerField: 'Id'
    };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Swimlane drag and drop

By default, Swimlane allows drag and drop across the columns within the swimlane row. Kanban does not allow dragging the cards across the swimlane rows.

Enabling the dragAndDrop property allows you to drag the cards across the swimlane rows, which is specified inside the swimlaneSettings property.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { KanbanModule } from '@syncfusion/ej2-angular-kanban'
import { Component } from '@angular/core';
import { CardSettingsModel, SwimlaneSettingsModel } from '@syncfusion/ej2-angular-kanban';
import { kanbanData } from './datasource';

@Component({
    imports: [
        KanbanModule
    ],
    standalone: true,
    selector: 'app-root',
    template: `<ejs-kanban keyField='Status' [dataSource]='data' [cardSettings]='cardSettings' [swimlaneSettings]='swimlaneSettings'>
                <e-columns>
                  <e-column headerText='To do' keyField='Open'></e-column>
                  <e-column headerText='In Progress' keyField='InProgress'></e-column>
                  <e-column headerText='Testing' keyField='Testing'></e-column>
                  <e-column headerText='Done' keyField='Close'></e-column>
                </e-columns>
            </ejs-kanban>`
})
export class AppComponent {
    public data: Object[] = kanbanData;
    public cardSettings: CardSettingsModel = {
        contentField: 'Summary',
        headerField: 'Id'
    };
    public swimlaneSettings: SwimlaneSettingsModel = { keyField: 'Assignee', allowDragAndDrop: true };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

External drag and drop

Allows the user to drag and drop the cards from one kanban to another kanban or Kanban to an external source and vice versa.

Kanban to kanban

Drag and drop the card from one kanban to another kanban and vice versa. This can be achieved by specifying the externalDropId property which is used to specify the id of the dropped kanban element and the dragStop event which is used to delete the card on dragged Kanban and add the card on dropped Kanban using the deleteCard and addCard public methods.

Before adding a card to dropped kanban, you can manually change the card data headerField when the same card data headerField is dropped to another Kanban.

In the following example, Drag the card from one Kanban and drop it into another kanban using the dragStop event. In this event, remove the card from the dragged Kanban by using the deleteCard public method and add the card to the dropped Kanban by using the addCard public method.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { KanbanModule } from '@syncfusion/ej2-angular-kanban'
import { Component, ViewChild } from '@angular/core';
import { closest } from '@syncfusion/ej2-base';
import { CardSettingsModel, DragEventArgs, KanbanComponent } from '@syncfusion/ej2-angular-kanban';
import { kanbanAData, kanbanBData } from './datasource';
@Component({
    imports: [
      KanbanModule
    ],
    standalone: true,
    selector: 'app-root',
    template: `<div class="container-fluid">
        <div class="row">
          <div class="col-sm-6">
          <h4>Kanban A</h4>
          <ejs-kanban id='KanbanA' #KanbanA keyField='Status' [dataSource]='dataA' [externalDropId]='externalKanbanADropId'
            [cardSettings]='cardSettings' (dragStop)='onKanbanADragStop($event)'>
            <e-columns>
              <e-column headerText='To do' keyField='Open'></e-column>
              <e-column headerText='Done' keyField='Close'></e-column>
            </e-columns>
          </ejs-kanban>
        </div>
          <div class="col-sm-6">
          <h4>Kanban B</h4>
          <ejs-kanban id='KanbanB' #KanbanB keyField='Status' [dataSource]='dataB' [externalDropId]='externalKanbanBDropId'
            [cardSettings]='cardSettings' (dragStop)='onKanbanBDragStop($event)'>
            <e-columns>
              <e-column headerText='To do' keyField='Open'></e-column>
              <e-column headerText='Done' keyField='Close'></e-column>
            </e-columns>
          </ejs-kanban>
        </div>
        </div>
      </div>`
})
export class AppComponent {
    @ViewChild('KanbanA')
    public kanbanObjA?: KanbanComponent;
    @ViewChild('KanbanB')
    public kanbanObjB?: KanbanComponent;
    public dataA: Object[] = kanbanAData;
    public dataB: Object[] = kanbanBData;
    public cardSettings: CardSettingsModel = {
      contentField: 'Summary',
      headerField: 'Id'
    };
    public externalKanbanADropId: string[] = ["#KanbanB"];
    public externalKanbanBDropId: string[] = ["#KanbanA"];
    onKanbanADragStop(args: DragEventArgs) {
      let kanbanBElement: Element = <Element>closest(args.event.target as Element, '#KanbanB');
      if (kanbanBElement) {
        (this.kanbanObjA as KanbanComponent).deleteCard(args.data);
        (this.kanbanObjB as KanbanComponent).addCard(args.data, args.dropIndex);
        args.cancel = true;
      }
    };
    onKanbanBDragStop(args: DragEventArgs) {
      let kanbanAElement: Element = <Element>closest(args.event.target as Element, '#KanbanA');
      if (kanbanAElement) {
        (this.kanbanObjB as KanbanComponent).deleteCard(args.data);
        (this.kanbanObjA as KanbanComponent).addCard(args.data, args.dropIndex);
        args.cancel = true;
      }
    };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Treeview to Kanban

Drag the card from the Kanban board and drop it to the Treeview component and vice versa.

In the following sample, remove the data from the Kanban board using the deleteCard public method and add to the Treeview component using the addNodes public method at Kanban dragStop event when dragging the card and dropping it to the Treeview component. Remove the data from Treeview using the removeNodes public method and add to Kanban board using the openDialog public method when dragging the list from the Treeview component and dropping it to the kanban board.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { KanbanModule } from '@syncfusion/ej2-angular-kanban'
import { TreeViewModule } from '@syncfusion/ej2-angular-navigations'
import { Component, ViewChild } from '@angular/core';
import { closest } from '@syncfusion/ej2-base';
import { CardSettingsModel, DragEventArgs, KanbanComponent } from '@syncfusion/ej2-angular-kanban';
import { kanbanData, treeViewData } from './datasource';
import { TreeViewComponent } from '@syncfusion/ej2-angular-navigations';
import { DragAndDropEventArgs } from '@syncfusion/ej2-navigations';
@Component({
    imports: [
      KanbanModule,
      TreeViewModule
    ],
    standalone: true,
    selector: 'app-root',
    template: `<div class="container-fluid">
        <div class="row">
          <div class="col-md-6">
          <h4>Kanban</h4>
          <ejs-kanban id='Kanban' #Kanban keyField='Status' [dataSource]='data' [externalDropId]='externalKanbanDropId'
            [cardSettings]='cardSettings' (dragStop)='onKanbanDragStop($event)'>
            <e-columns>
              <e-column headerText='To do' keyField='Open'></e-column>
                <e-column headerText='Done' keyField='Close'></e-column>
            </e-columns>
          </ejs-kanban>
        </div>
        <div class="col-md-6">
          <h4>TreeView</h4>
          <ejs-treeview id='TreeView' #TreeView [fields]='field' [allowDragAndDrop]='allowDragAndDrop' (nodeDragStop)="onTreeDragStop($event)">
              <ng-template #nodeTemplate="" let-data="">
                  <div id="treelist">
                    <div id="treeviewlist"> - </div>
                  </div>
              </ng-template>
          </ejs-treeview>
        </div>
      </div>
    </div>`
})
export class AppComponent {
    @ViewChild('Kanban')
    public kanbanObj?: KanbanComponent;
    @ViewChild('TreeView')
    public treeObj?: TreeViewComponent;
    public data: Object[] = kanbanData;
    public cardSettings: CardSettingsModel = {
      contentField: 'Summary',
      headerField: 'Id'
    };
    public externalKanbanDropId: string[] = ['#TreeView'];
    public field: Object = { dataSource: treeViewData, id: 'Id', text: 'Status' };
    public allowDragAndDrop: boolean = true;
    onKanbanDragStop(args: DragEventArgs) {
      let treeViewElement: Element = <Element>closest(args.event.target as Element, '#TreeView');
      if (treeViewElement) {
        (this.kanbanObj as KanbanComponent).deleteCard(args.data);
        (this.treeObj as TreeViewComponent).addNodes(args.data);
        args.cancel = true;
      }
    };
    onTreeDragStop(args: DragAndDropEventArgs) {
      let kanbanElement: Element = <Element>closest(args.event.target as Element, '#Kanban');
      if (kanbanElement) {
        let treeData: { [key: string]: Object }[] =
          (this.treeObj as TreeViewComponent).fields.dataSource as { [key: string]: Object }[];
        const filteredData: { [key: string]: Object }[] =
          treeData.filter((item: any) => item.Id === parseInt(args.draggedNodeData['id'] as string, 10));
        (this.treeObj as TreeViewComponent).removeNodes([args.draggedNodeData['id']] as string[]);
        (this.kanbanObj as KanbanComponent).openDialog('Add', filteredData[0]);
        args.cancel = true;
      }
    };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Schedule to Kanban

Drag the card from the Kanban board and drop it to the Schedule component and vice versa.

In the following sample, remove the data from the Kanban board using the deleteCard public method and add to the schedule component using the addNodes public method at Kanban dragStop event when dragging the card and dropping it to the Treeview component. Remove the data from Treeview using the removeNodes public method and add to Kanban board using the addCard public method when dragging the list from the Treeview component and dropping it to the kanban board.

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { KanbanModule } from '@syncfusion/ej2-angular-kanban';
import { ScheduleModule, RecurrenceEditorAllModule, } from '@syncfusion/ej2-angular-schedule';
import { Component, ViewChild } from '@angular/core';
import { closest, removeClass, extend } from '@syncfusion/ej2-base';
import { CardSettingsModel, DragEventArgs, KanbanComponent, } from '@syncfusion/ej2-angular-kanban';
import { kanbanData, scheduleData }  from './datasource';
import { EventSettingsModel, TimelineViewsService, TimelineMonthService, ResizeService, DragAndDropService, ScheduleComponent,
    View, WorkHoursModel, GroupModel, ResourceDetails, ResourcesModel,
} from '@syncfusion/ej2-angular-schedule';

@Component({
    imports: [KanbanModule, ScheduleModule, RecurrenceEditorAllModule],
    standalone: true,
    selector: 'app-root',
    template: `<div class="container-fluid">
        <div class="row">
          <div class="col-md-4" style="width: 30%">
          <h4>Kanban</h4>
          <ejs-kanban id='Kanban' #Kanban keyField='DepartmentName' [dataSource]='data' [externalDropId]='externalKanbanDropId'
            [cardSettings]='cardSettings' (dragStop)='onKanbanDragStop($event)'>
            <e-columns>
              <e-column headerText='GENERAL' keyField='GENERAL'></e-column>
            </e-columns>
          </ejs-kanban>
        </div>
        <div class="col-md-8" style="width: 70%">
          <h4>Schedule</h4>
          <ejs-schedule id='Schedule' #Schedule width='100%' height='650px' [group]="group" [currentView]="currentView" [selectedDate]="selectedDate" [workHours]="workHours" [eventSettings]="eventSettings" (dragStop)="scheduleDragStop($event)">
                  <e-resources>
                      <e-resource field='DepartmentID' title='Department' name='Departments' [dataSource]='departmentDataSource' textField='Text' idField='Id' colorField='Color'>
                      </e-resource>
                      <e-resource field='ConsultantID' title='Consultant' name='Consultants' [dataSource]='consultantDataSource' [allowMultiple]='allowMultiple' textField='Text' idField='Id' groupIDField="GroupId" colorField='Color'>
                      </e-resource>
                  </e-resources>
                  <ng-template #resourceHeaderTemplate let-data>
                      <div class="template-wrap">
                          <div class="specialist-category">
                              <div class="specialist-name"></div>
                              <div class="specialist-designation"></div>
                          </div>
                      </div>
                  </ng-template>
                  <e-views>
                      <e-view option='TimelineDay'></e-view>
                      <e-view option='TimelineMonth'></e-view>
                  </e-views>
              </ejs-schedule>
        </div>
      </div>
    </div>`,
    providers: [
      TimelineViewsService,
      TimelineMonthService,
      ResizeService,
      DragAndDropService,
    ],
})
export class AppComponent {
    @ViewChild('Kanban')
    public kanbanObj?: KanbanComponent;
    @ViewChild('Schedule')
    public scheduleObj?: ScheduleComponent;
    public data: Object[] = kanbanData;
    public scheduleDataSource: Object[] = <Object[]>(
      extend([], scheduleData, undefined, true)
    );
    public cardSettings: CardSettingsModel = {
      contentField: 'Name',
      headerField: 'Id',
    };
    public externalKanbanDropId: string[] = ['#Schedule'];
    public selectedDate: Date = new Date(2018, 7, 1);
    public currentView: View = 'TimelineDay';
    public workHours: WorkHoursModel = { start: '08:00', end: '18:00' };
    public departmentDataSource: Object[] = [
      { Text: 'GENERAL', Id: 1, Color: '#bbdc00' },
      { Text: 'DENTAL', Id: 2, Color: '#9e5fff' },
    ];
    public consultantDataSource: Object[] = [
      {
        Text: 'Alice',
        Id: 1,
        GroupId: 1,
        Color: '#bbdc00',
        Designation: 'Cardiologist',
      },
      {
        Text: 'Nancy',
        Id: 2,
        GroupId: 2,
        Color: '#9e5fff',
        Designation: 'Orthodontist',
      },
      {
        Text: 'Robert',
        Id: 3,
        GroupId: 1,
        Color: '#bbdc00',
        Designation: 'Optometrist',
      },
      {
        Text: 'Robson',
        Id: 4,
        GroupId: 2,
        Color: '#9e5fff',
        Designation: 'Periodontist',
      },
      {
        Text: 'Laura',
        Id: 5,
        GroupId: 1,
        Color: '#bbdc00',
        Designation: 'Orthopedic',
      },
      {
        Text: 'Margaret',
        Id: 6,
        GroupId: 2,
        Color: '#9e5fff',
        Designation: 'Endodontist',
      },
    ];
    public group: GroupModel = {
      enableCompactView: false,
      resources: ['Departments', 'Consultants'],
    };
    public allowMultiple: Boolean = false;
    public eventSettings: EventSettingsModel = {
      dataSource: this.scheduleDataSource,
      fields: {
        subject: { title: 'Patient Name', name: 'Name' },
        startTime: { title: 'From', name: 'StartTime' },
        endTime: { title: 'To', name: 'EndTime' },
        description: { title: 'Reason', name: 'Description' },
      },
    };

    getConsultantName(value: ResourceDetails): string {
      return (value as ResourceDetails).resourceData[
        ((value as ResourceDetails).resource as ResourcesModel)
          .textField as string
      ] as string;
    }

    getConsultantStatus(value: ResourceDetails): boolean {
      let resourceName: string = (value as ResourceDetails).resourceData[
        ((value as ResourceDetails).resource as ResourcesModel)
          .textField as string
      ] as string;
      if (resourceName === 'GENERAL' || resourceName === 'DENTAL') {
        return false;
      } else {
        return true;
      }
    }

    getConsultantDesignation(value: ResourceDetails): string {
      let resourceName: string = (value as ResourceDetails).resourceData[
        ((value as ResourceDetails).resource as ResourcesModel)
          .textField as string
      ] as string;
      if (resourceName === 'GENERAL' || resourceName === 'DENTAL') {
        return '';
      } else {
        return (value as ResourceDetails).resourceData['Designation'] as string;
      }
    }

    getConsultantImageName(value: ResourceDetails): string {
      return this.getConsultantName(value).toLowerCase();
    }

    onKanbanDragStop(args: DragEventArgs) {
      let scheduleElement: Element = <Element>(
        closest(args.event.target as Element, '#Schedule')
      );
      if (scheduleElement) {
        (this.kanbanObj as KanbanComponent).deleteCard(args.data);
        (this.kanbanObj as any).openEditor(args.data[0], 'Add', true);
        args.cancel = true;
      }
    }
    scheduleDragStop(args: any) {
      let kanbanElement: Element = <Element>(
        closest(args.event.target as Element, '#Kanban')
      );
      if (kanbanElement) {
        (this.scheduleObj as ScheduleComponent).deleteEvent(args.data.Id);
        removeClass(
          [
            (this.scheduleObj as ScheduleComponent).element.querySelector(
              '.e-selected-cell'
            ) as Element,
          ],
          'e-selected-cell'
        );
        this.kanbanObj?.openDialog('Add', args.data);
        args.cancel = true;
      }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Syncfusion AI Assistant

How can I help you?

Drag and drop in Vue Kanban component

25 May 202424 minutes to read

All cards can be dragged and dropped across the columns or within the columns or swimlane row or kanban to an external source and vice versa.

The following drag and drop types are available in the Kanban board.

  • Internal drag and drop
    • Column drag and drop
    • Swimlane drag and drop
  • External drag and drop
    • Kanban to Kanban
    • Kanban to External source and vice versa.

Dropped card position varies based on the sortSettings property.

Internal drag and drop

Allows the user to drag and drop the cards within the kanban board. Based on this, we can categorize into two ways.

  • Column drag and drop
  • Swimlane drag and drop

Column drag and drop

By default, all cards can be dragged and dropped across the columns and within the columns. You cannot drag and drop the cards when disabling the allowDragAndDrop property.

You can prevent the drag or drop behavior of the particular column by disabling the allowDrag or allowDrop property.
You can also control the flow of transition cards between the columns by using the transitionColumns property.

In the following example, disable the drag and drop behavior on the Kanban board.

<template>
  <div id="app">
       <ejs-kanban id="kanban" keyField="Status" :dataSource="kanbanData"
        :cardSettings="cardSettings" :allowDragAndDrop="false">
          <e-columns>
            <e-column headerText="To Do" keyField="Open"></e-column>
            <e-column headerText="In Progress" keyField="InProgress"></e-column>
            <e-column headerText="Testing" keyField="Testing"></e-column>
            <e-column headerText="Done" keyField="Close"></e-column>
          </e-columns>
        </ejs-kanban>
  </div>
</template>

<script setup>

import { KanbanComponent as EjsKanban, ColumnsDirective as EColumns, ColumnDirective as EColumn } from '@syncfusion/ej2-vue-kanban';
import { extend } from '@syncfusion/ej2-base';
import { kanbanData } from './datasource.js';

kanbanData = extend([], kanbanData, null, true);
const cardSettings = {
  contentField: "Summary",
  headerField: "Id"
};

</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-layouts/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-vue-kanban/styles/tailwind3.css';
</style>
<template>
  <div id="app">
       <ejs-kanban id="kanban" keyField="Status" :dataSource="kanbanData"
        :cardSettings="cardSettings" :allowDragAndDrop="false">
          <e-columns>
            <e-column headerText="To Do" keyField="Open"></e-column>
            <e-column headerText="In Progress" keyField="InProgress"></e-column>
            <e-column headerText="Testing" keyField="Testing"></e-column>
            <e-column headerText="Done" keyField="Close"></e-column>
          </e-columns>
        </ejs-kanban>
  </div>
</template>

<script>

import { KanbanComponent, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-vue-kanban';
import { extend } from '@syncfusion/ej2-base';
import { kanbanData } from './datasource.js';

export default {
name: "App",
components: {
"ejs-kanban":KanbanComponent,
"e-columns":ColumnsDirective,
"e-column":ColumnDirective
},
  data: function() {
    return {
      kanbanData: extend([], kanbanData, null, true),
      cardSettings: {
        contentField: "Summary",
        headerField: "Id"
      }
    };
  },
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-layouts/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-vue-kanban/styles/tailwind3.css';
</style>

Swimlane drag and drop

By default, Swimlane allows drag and drop across the columns within the swimlane row. Kanban does not allow dragging the cards across the swimlane rows.

Enabling the dragAndDrop property allows you to drag the cards across the swimlane rows, which is specified inside the swimlaneSettings property.

<template>
  <div id="app">
       <ejs-kanban id="kanban" keyField="Status" :dataSource="kanbanData"
        :cardSettings="cardSettings" :swimlaneSettings="swimlaneSettings">
          <e-columns>
            <e-column headerText="To Do" keyField="Open"></e-column>
            <e-column headerText="In Progress" keyField="InProgress"></e-column>
            <e-column headerText="Testing" keyField="Testing"></e-column>
            <e-column headerText="Done" keyField="Close"></e-column>
          </e-columns>
        </ejs-kanban>
  </div>
</template>

<script setup>

import { KanbanComponent as EjsKanban, ColumnsDirective as EColumns, ColumnDirective as EColumn} from '@syncfusion/ej2-vue-kanban';
import { extend } from '@syncfusion/ej2-base';
import { kanbanData } from './datasource.js';

kanbanData = extend([], kanbanData, null, true);
const cardSettings = {
  contentField: "Summary",
  headerField: "Id"
};
const swimlaneSettings = {
  keyField: 'Assignee',
  allowDragAndDrop: true
};

</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-layouts/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-vue-kanban/styles/tailwind3.css';
</style>
<template>
  <div id="app">
       <ejs-kanban id="kanban" keyField="Status" :dataSource="kanbanData"
        :cardSettings="cardSettings" :swimlaneSettings="swimlaneSettings">
          <e-columns>
            <e-column headerText="To Do" keyField="Open"></e-column>
            <e-column headerText="In Progress" keyField="InProgress"></e-column>
            <e-column headerText="Testing" keyField="Testing"></e-column>
            <e-column headerText="Done" keyField="Close"></e-column>
          </e-columns>
        </ejs-kanban>
  </div>
</template>

<script>

import { KanbanComponent, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-vue-kanban';
import { extend } from '@syncfusion/ej2-base';
import { kanbanData } from './datasource.js';

export default {
name: "App",
components: {
"ejs-kanban":KanbanComponent,
"e-columns":ColumnsDirective,
"e-column":ColumnDirective
},
  data: function() {
    return {
      kanbanData: extend([], kanbanData, null, true),
      cardSettings: {
        contentField: "Summary",
        headerField: "Id",
      },
      swimlaneSettings: {
        keyField: 'Assignee',
        allowDragAndDrop: true
      }
    };
  },
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-layouts/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-vue-kanban/styles/tailwind3.css';
</style>

External drag and drop

Allows the user to drag and drop the cards from one kanban to another kanban or Kanban to an external source and vice versa.

Kanban to kanban

Drag and drop the card from one kanban to another kanban and vice versa. This can be achieved by specifying the externalDropId property which is used to specify the id of the dropped kanban element and the dragStop event which is used to delete the card on dragged Kanban and add the card on dropped Kanban using the deleteCard and addCard public methods.

Before adding a card to dropped kanban, you can manually change the card data headerField when the same card data headerField is dropped to another Kanban.

In the following example, Drag the card from one Kanban and drop it into another kanban using the dragStop event. In this event, remove the card from the dragged Kanban by using the deleteCard public method and add the card to the dropped Kanban by using the addCard public method.

<template>
  <div id="app">
  <div class="container-fluid">
    <div class="row">
      <div class="col-sm-6">
      <h4>Kanban A</h4>
       <ejs-kanban id="kanbanA" ref="kanbanObjA" keyField="Status" :dataSource="kanbanData"
        :cardSettings="cardSettings" :externalDropId='externalKanbanADropId' :dragStop="kanbanDragStopA">
          <e-columns>
            <e-column headerText="To Do" keyField="Open"></e-column>
            <e-column headerText="Done" keyField="Close"></e-column>
          </e-columns>
        </ejs-kanban>
      </div>
      <div class="col-sm-6">
        <h4>Kanban B</h4>
        <ejs-kanban id="kanbanB" ref="kanbanObjB" keyField="Status" :dataSource="kanbanData"
        :cardSettings="cardSettings" :externalDropId='externalKanbanBDropId' :dragStop="kanbanDragStopB">
          <e-columns>
            <e-column headerText="To Do" keyField="Open"></e-column>
           <e-column headerText="Done" keyField="Close"></e-column>
          </e-columns>
        </ejs-kanban>
      </div>
    </div>
  </div>
 </div>
</template>

<script setup>

import { KanbanComponent as EjsKanban, ColumnDirective as EColumn, ColumnsDirective as EColumns } from '@syncfusion/ej2-vue-kanban';
import { extend, closest } from '@syncfusion/ej2-base';
import { kanbanData } from './datasource.js';
import {ref} from 'vue';

const kanbanObjA = ref(null);
const kanbanObjB = ref(null);

const cardSettings = {
  contentField: "Summary",
  headerField: "Id"
};

const externalKanbanADropId = ['#kanbanB'];
const externalKanbanBDropId = ['#kanbanA'];

const kanbanDragStopA = function (args) {
    let kanbanBElement = closest(args.event.target, '#kanbanB');
    let kanbanObjA = kanbanObjA.value.ej2Instances;
    let kanbanObjB = kanbanObjB.value.ej2Instances;
    if (kanbanBElement) {
      kanbanObjA.deleteCard(args.data);
      args.data.forEach((card, i) => {
          const index = kanbanObjB.kanbanData.findIndex((colData) =>
              colData[kanbanObjB.cardSettings.headerField] === card[kanbanObjB.cardSettings.headerField]);
          if (index !== -1) {
              card[kanbanObjB.cardSettings.headerField] = Math.max(...kanbanObjB.kanbanData.map(
                  (obj) => parseInt(obj[kanbanObjB.cardSettings.headerField], 10))) + ++i;
          }
      });
      kanbanObjB.addCard(args.data, args.dropIndex);
      args.cancel = true;
  }
};

const kanbanDragStopB = function (args) {
  let kanbanAElement = closest(args.event.target, '#kanbanA');
  let kanbanObjA = kanbanObjA.value.ej2Instances;
  let kanbanObjB = kanbanObjB.value.ej2Instances;
  if (kanbanAElement) {
      kanbanObjB.deleteCard(args.data);
      args.data.forEach((card, i) => {
      const index = kanbanObjA.kanbanData.findIndex((colData) =>
          colData[kanbanObjA.cardSettings.headerField] === card[kanbanObjA.cardSettings.headerField]);
      if (index !== -1) {
          card[kanbanObjA.cardSettings.headerField] = Math.max(...kanbanObjA.kanbanData.map(
              (obj) => parseInt(obj[kanbanObjA.cardSettings.headerField], 10))) + ++i;
      }
  });
  kanbanObjA.addCard(args.data, args.dropIndex);
  args.cancel = true;
  }
};

</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-layouts/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-vue-kanban/styles/tailwind3.css';
.row {
  display: flex;
}
</style>
<template>
  <div id="app">
  <div class="container-fluid">
    <div class="row">
      <div class="col-sm-6">
      <h4>Kanban A</h4>
       <ejs-kanban id="kanbanA" ref="kanbanObjA" keyField="Status" :dataSource="kanbanData"
        :cardSettings="cardSettings" :externalDropId='externalKanbanADropId' :dragStop="kanbanDragStopA">
          <e-columns>
            <e-column headerText="To Do" keyField="Open"></e-column>
            <e-column headerText="Done" keyField="Close"></e-column>
          </e-columns>
        </ejs-kanban>
      </div>
      <div class="col-sm-6">
        <h4>Kanban B</h4>
        <ejs-kanban id="kanbanB" ref="kanbanObjB" keyField="Status" :dataSource="kanbanData"
        :cardSettings="cardSettings" :externalDropId='externalKanbanBDropId' :dragStop="kanbanDragStopB">
          <e-columns>
            <e-column headerText="To Do" keyField="Open"></e-column>
           <e-column headerText="Done" keyField="Close"></e-column>
          </e-columns>
        </ejs-kanban>
      </div>
    </div>
  </div>
 </div>
</template>

<script>

import { KanbanComponent, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-vue-kanban';
import { extend, closest } from '@syncfusion/ej2-base';
import { kanbanData } from './datasource.js';

export default {
name: "App",
components: {
"ejs-kanban":KanbanComponent,
"e-columns":ColumnsDirective,
"e-column":ColumnDirective
},
  data: function() {
    return {
      kanbanData: extend([], kanbanData, null, true),
      cardSettings: {
        contentField: "Summary",
        headerField: "Id"
      },
      externalKanbanADropId: ['#kanbanB'],
      externalKanbanBDropId: ['#kanbanA']
    };
  },
   methods: {
      kanbanDragStopA: function (args) {
          let kanbanBElement = closest(args.event.target, '#kanbanB');
          let kanbanObjA = this.$refs.kanbanObjA.ej2Instances;
          let kanbanObjB = this.$refs.kanbanObjB.ej2Instances;
          if (kanbanBElement) {
            kanbanObjA.deleteCard(args.data);
            args.data.forEach((card, i) => {
                const index = kanbanObjB.kanbanData.findIndex((colData) =>
                    colData[kanbanObjB.cardSettings.headerField] === card[kanbanObjB.cardSettings.headerField]);
                if (index !== -1) {
                    card[kanbanObjB.cardSettings.headerField] = Math.max(...kanbanObjB.kanbanData.map(
                        (obj) => parseInt(obj[kanbanObjB.cardSettings.headerField], 10))) + ++i;
                }
            });
            kanbanObjB.addCard(args.data, args.dropIndex);
            args.cancel = true;
        }
      },
      kanbanDragStopB: function (args) {
        let kanbanAElement = closest(args.event.target, '#kanbanA');
        let kanbanObjA = this.$refs.kanbanObjA.ej2Instances;
        let kanbanObjB = this.$refs.kanbanObjB.ej2Instances;
        if (kanbanAElement) {
            kanbanObjB.deleteCard(args.data);
            args.data.forEach((card, i) => {
            const index = kanbanObjA.kanbanData.findIndex((colData) =>
                colData[kanbanObjA.cardSettings.headerField] === card[kanbanObjA.cardSettings.headerField]);
            if (index !== -1) {
                card[kanbanObjA.cardSettings.headerField] = Math.max(...kanbanObjA.kanbanData.map(
                    (obj) => parseInt(obj[kanbanObjA.cardSettings.headerField], 10))) + ++i;
            }
        });
        kanbanObjA.addCard(args.data, args.dropIndex);
        args.cancel = true;
        }
      }
   }
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-layouts/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-vue-kanban/styles/tailwind3.css';
.row {
  display: flex;
}
</style>

Treeview to Kanban

Drag the card from the Kanban board and drop it to the Treeview component and vice versa.

In the following sample, remove the data from the Kanban board using the deleteCard public method and add to the Treeview component using the addNodes public method at Kanban dragStop event when dragging the card and dropping it to the Treeview component. Remove the data from Treeview using the removeNodes public method and add to Kanban board using the openDialog public method when dragging the list from the Treeview component and dropping it to the kanban board.

<template>
  <div id="app">
  <div class="container-fluid">
    <div class="row">
      <div class="col-sm-6">
        <h4>Kanban</h4>
       <ejs-kanban id="kanban" ref="kanbanObj" keyField="Status" :dataSource="kanbanData"
        :cardSettings="cardSettings" :externalDropId='externalKanbanDropId' :dragStop="kanbanDragStop">
          <e-columns>
            <e-column headerText="To Do" keyField="Open"></e-column>
            <e-column headerText="Done" keyField="Close"></e-column>
          </e-columns>
        </ejs-kanban>
        </div>
      <div class="col-sm-6">
        <h4>TreeView</h4>
            <ejs-treeview id='treeView' ref="treeViewObj" :nodeTemplate="treeTemplate" :fields='treeViewFields' :allowDragAndDrop=true :nodeDragStop="onItemDragStop"></ejs-treeview>
        </div>
    </div>
  </div>
</div>
</template>

<script setup>

import { KanbanComponent as EjsKanban, ColumnsDirective as EColumns, ColumnDirective as EColumn } from '@syncfusion/ej2-vue-kanban';
import { extend, closest } from '@syncfusion/ej2-base';
import { kanbanData, treeViewData } from './datasource.js';

import { TreeViewComponent as EjsTreeview} from "@syncfusion/ej2-vue-navigations";
import { createApp, ref } from "vue";

const app = createApp();
const treeViewObj = ref(null);
const kanbanObj = ref(null);

 var treeVue = app.component("tree-template", {
  data: () => ({}),
  template: '<div id="treelist"><div id="treeviewlist"> - </div></div>'
});

kanbanData = extend([], kanbanData, null, true);
const cardSettings = {
  contentField: "Summary",
  headerField: "Id"
};
const externalKanbanDropId = ['#treeView'];
const treeViewFields = { dataSource: treeViewData, id: 'Id', text: 'Status' };
const treeTemplate = function(e) {
    return { template: treeVue }
}

const kanbanDragStop = function (args) {
    let treeViewElement = closest(args.event.target, '#treeView');
    let kanbanObj = kanbanObj.value.ej2Instances;
    let treeObj = treeViewObj.value.ej2Instances;
    if (treeViewElement) {
      kanbanObj.deleteCard(args.data);
      treeObj.addNodes(args.data);
      args.cancel = true;
    }
};

const onItemDragStop = function (args) {
  let kanbanElement = closest(args.event.target, '#kanban');
  let kanbanObj = kanbanObj.value.ej2Instances;
  let treeObj = treeViewObj.value.ej2Instances;
  if (kanbanElement) {
    let treeData =
      treeObj.fields.dataSource;
    const filteredData =
      treeData.filter((item) => item.Id === parseInt(args.draggedNodeData.id, 10));
    treeObj.removeNodes([args.draggedNodeData.id]);
    kanbanObj.openDialog('Add', filteredData[0]);
    args.cancel = true;
  }
};

</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-layouts/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-vue-kanban/styles/tailwind3.css';
.row {
  display: flex;
}
</style>
<template>
  <div id="app">
  <div class="container-fluid">
    <div class="row">
      <div class="col-sm-6">
        <h4>Kanban</h4>
       <ejs-kanban id="kanban" ref="kanbanObj" keyField="Status" :dataSource="kanbanData"
        :cardSettings="cardSettings" :externalDropId='externalKanbanDropId' :dragStop="kanbanDragStop">
          <e-columns>
            <e-column headerText="To Do" keyField="Open"></e-column>
            <e-column headerText="Done" keyField="Close"></e-column>
          </e-columns>
        </ejs-kanban>
        </div>
      <div class="col-sm-6">
        <h4>TreeView</h4>
            <ejs-treeview id='treeView' ref="treeViewObj" :nodeTemplate="treeTemplate" :fields='treeViewFields' :allowDragAndDrop=true :nodeDragStop="onItemDragStop"></ejs-treeview>
        </div>
    </div>
  </div>
</div>
</template>

<script>

import { KanbanComponent, ColumnDirective, ColumnsDirective } from '@syncfusion/ej2-vue-kanban';
import { extend, closest } from '@syncfusion/ej2-base';
import { kanbanData, treeViewData } from './datasource.js';

import { TreeViewComponent } from "@syncfusion/ej2-vue-navigations";
import { createApp } from "vue";

const app = createApp();

 var treeVue = app.component("tree-template", {
        template: '<div id="treelist"><div id="treeviewlist"> - </div></div>',
        data() {
            return {
                data: {}
            };
        }
    });
export default {
name: "App",
components: {
"ejs-kanban":KanbanComponent,
"e-columns":ColumnsDirective,
"e-column":ColumnDirective,
"ejs-treeview":TreeViewComponent
},
  data: function() {
    return {
      kanbanData: extend([], kanbanData, null, true),
      cardSettings: {
        contentField: "Summary",
        headerField: "Id"
      },
      externalKanbanDropId: ['#treeView'],
      treeViewFields: { dataSource: treeViewData, id: 'Id', text: 'Status' },
      treeTemplate: function() {
          return { template: treeVue }
      }
    };
  },
   methods: {
      kanbanDragStop: function (args) {
          let treeViewElement = closest(args.event.target, '#treeView');
          let kanbanObj = this.$refs.kanbanObj.ej2Instances;
          let treeObj = this.$refs.treeViewObj.ej2Instances;
          if (treeViewElement) {
            kanbanObj.deleteCard(args.data);
            treeObj.addNodes(args.data);
            args.cancel = true;
          }
      },
      onItemDragStop: function (args) {
        let kanbanElement = closest(args.event.target, '#kanban');
        let kanbanObj = this.$refs.kanbanObj.ej2Instances;
        let treeObj = this.$refs.treeViewObj.ej2Instances;
        if (kanbanElement) {
          let treeData =
            treeObj.fields.dataSource;
          const filteredData =
            treeData.filter((item) => item.Id === parseInt(args.draggedNodeData.id, 10));
          treeObj.removeNodes([args.draggedNodeData.id]);
          kanbanObj.openDialog('Add', filteredData[0]);
          args.cancel = true;
        }
      }
   }
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-layouts/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-vue-kanban/styles/tailwind3.css';
.row {
  display: flex;
}
</style>

Schedule to Kanban

Drag the card from the Kanban board and drop it to the Schedule component and vice versa.

In the following sample, remove the data from the Kanban board using the deleteCard public method and add to the schedule component using the addNodes public method at Kanban dragStop event when dragging the card and dropping it to the Treeview component. Remove the data from Treeview using the removeNodes public method and add to Kanban board using the addCard public method when dragging the list from the Treeview component and dropping it to the kanban board.

<template>
  <div id="app">
  <div class="container-fluid">
    <div class="row">
      <div class="col-sm-6" style="width: 30%">
        <h4>Kanban</h4>
       <ejs-kanban id="kanban" ref="kanbanObj" keyField="DepartmentName" :dataSource="kanbanData"
        :cardSettings="cardSettings" :externalDropId='externalKanbanDropId' :dragStop="kanbanDragStop">
          <e-columns>
            <e-column headerText="GENERAL" keyField="GENERAL"></e-column>
          </e-columns>
        </ejs-kanban>
      </div>
      <div class="col-sm-6"  style="width: 70%">
        <h4>TreeView</h4>
          <ejs-schedule id='schedule' ref="scheduleObj" height="650px" :cssClass='cssClass' :selectedDate='selectedDate' :eventSettings='eventSettings'
                  :group='group' :currentView='currentView' :resourceHeaderTemplate='resourceHeaderTemplate' :dragStop="onItemDragStop">
                  <e-views>
                      <e-view option="TimelineDay"></e-view>
                      <e-view option="TimelineMonth"></e-view>
                  </e-views>
                  <e-resources>
                      <e-resource field='DepartmentID' title='Department' name='Departments' :dataSource='departmentDataSource'
                          textField='Text' idField='Id' colorField='Color'>
                      </e-resource>
                      <e-resource field='ConsultantID' title='Consultant' name='Consultants' :dataSource='consultantDataSource'
                          textField='Text' idField='Id' groupIDField='GroupId' colorField='Color'>
                      </e-resource>
                  </e-resources>
              </ejs-schedule>
        </div>
    </div>
  </div>
</div>
</template>

<script setup>
import { provide, createApp } from "vue";
import { KanbanComponent as EjsKanban, ColumnsDirective as EColumns, ColumnDirective as EColumn } from '@syncfusion/ej2-vue-kanban';
import { extend, closest } from '@syncfusion/ej2-base';
import { kanbanData, scheduleData } from './datasource.js';

import { ScheduleComponent as EjsSchedule, TimelineViews, TimelineMonth, Resize, DragAndDrop, ViewDirective as EView, ViewsDirective as EViews, ResourceDirective as EResource, ResourcesDirective as EResources } from "@syncfusion/ej2-vue-schedule";

const kanbanObj = ref(null);
const scheduleObj = ref(null);
const app = createApp({});
var resourceHeaderVue = app.component("resource-headerTemplate", {
  data: () => ({}),
  template: '<div className="template-wrap"><div class="specialist-category"><div v-if=getConsultantImageName(data)></div><div class="specialist-name">' +
                '</div><div class="specialist-designation"></div></div></div>',
      methods: {
          getConsultantName: function (data) {
              let value = JSON.parse(JSON.stringify(data));
              return (value.resourceData) ? value.resourceData[value.resource.textField] : value.resourceName;
          },
          getConsultantImageName: function (data) {
              let value = JSON.parse(JSON.stringify(data));
              let resourceName = (value.resourceData) ? value.resourceData[value.resource.textField] : value.resourceName;
              if (resourceName === 'GENERAL' || resourceName === 'DENTAL') {
                  return false;
              } else {
                  return true;
              }
          },
          getConsultantDesignation: function (data) {
              let value = JSON.parse(JSON.stringify(data));
              var resourceName = value.resourceData[value.resource.textField];
              if (resourceName === "GENERAL" || resourceName === "DENTAL") {
                  return '';
              } else {
                  return value.resourceData.Designation;
              }
          }
      }
});

kanbanData = extend([], kanbanData, null, true);
const cardSettings = {
  contentField: "Name",
  headerField: "Id"
};
const externalKanbanDropId = ['#schedule'];
const eventSettings = {
    dataSource: extend([], scheduleData, null, true),
    fields: {
        subject: { title: 'Patient Name', name: 'Name' },
        startTime: { title: "From", name: "StartTime" },
        endTime: { title: "To", name: "EndTime" },
        description: { title: 'Reason', name: 'Description' }
    },
};
const selectedDate = new Date(2018, 7, 1);
const currentView = 'TimelineDay';
const cssClass = 'schedule-drag-drop';
const group = {
    enableCompactView: false,
    resources: ['Departments', 'Consultants']
};
const departmentDataSource = [
    { Text: 'GENERAL', Id: 1, Color: '#bbdc00' },
    { Text: 'DENTAL', Id: 2, Color: '#9e5fff' }
];
const consultantDataSource = [
    { Text: 'Alice', Id: 1, GroupId: 1, Color: '#bbdc00', Designation: 'Cardiologist' },
    { Text: 'Nancy', Id: 2, GroupId: 2, Color: '#9e5fff', Designation: 'Orthodontist' },
    { Text: 'Robert', Id: 3, GroupId: 1, Color: '#bbdc00', Designation: 'Optometrist' },
    { Text: 'Robson', Id: 4, GroupId: 2, Color: '#9e5fff', Designation: 'Periodontist' },
    { Text: 'Laura', Id: 5, GroupId: 1, Color: '#bbdc00', Designation: 'Orthopedic' },
    { Text: 'Margaret', Id: 6, GroupId: 2, Color: '#9e5fff', Designation: 'Endodontist' }
];
const resourceHeaderTemplate = function () {
    return { template: resourceHeaderVue }
};
const kanbanDragStop = function (args) {
    let scheduleElement = closest(args.event.target, '#schedule');
    let kanbanObj = kanbanObj.value.ej2Instances;
    let scheduleObj = scheduleObj.value.ej2Instances;
    if (scheduleElement) {
        kanbanObj.deleteCard(args.data);
        scheduleObj.openEditor(args.data[0], 'Add', true);
        args.cancel = true;
    }
};
const onItemDragStop = function (args) {
    let kanbanElement = closest(args.event.target, '#kanban');
    let kanbanObj = kanbanObj.value.ej2Instances;
    let scheduleObj = scheduleObj.value.ej2Instances;
    if (kanbanElement) {
        scheduleObj.deleteEvent(args.data.Id);
         removeClass([scheduleObj.element.querySelector('.e-selected-cell')], 'e-selected-cell');
         kanbanObj.openDialog('Add', args.data);
         args.cancel = true;
    }
};

provide('schedule',  [TimelineViews, TimelineMonth, Resize, DragAndDrop]);

</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-layouts/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-calendars/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-excel-export/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-file-utils/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-schedule/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-compression/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-vue-kanban/styles/tailwind3.css';
.row {
  display: flex;
}
</style>
<template>
  <div id="app">
  <div class="container-fluid">
    <div class="row">
      <div class="col-sm-6" style="width: 30%">
        <h4>Kanban</h4>
       <ejs-kanban id="kanban" ref="kanbanObj" keyField="DepartmentName" :dataSource="kanbanData"
        :cardSettings="cardSettings" :externalDropId='externalKanbanDropId' :dragStop="kanbanDragStop">
          <e-columns>
            <e-column headerText="GENERAL" keyField="GENERAL"></e-column>
          </e-columns>
        </ejs-kanban>
      </div>
      <div class="col-sm-6"  style="width: 70%">
        <h4>TreeView</h4>
          <ejs-schedule id='schedule' ref="scheduleObj" height="650px" :cssClass='cssClass' :selectedDate='selectedDate' :eventSettings='eventSettings'
                  :group='group' :currentView='currentView' :resourceHeaderTemplate='resourceHeaderTemplate' :dragStop="onItemDragStop">
                  <e-views>
                      <e-view option="TimelineDay"></e-view>
                      <e-view option="TimelineMonth"></e-view>
                  </e-views>
                  <e-resources>
                      <e-resource field='DepartmentID' title='Department' name='Departments' :dataSource='departmentDataSource'
                          textField='Text' idField='Id' colorField='Color'>
                      </e-resource>
                      <e-resource field='ConsultantID' title='Consultant' name='Consultants' :dataSource='consultantDataSource'
                          textField='Text' idField='Id' groupIDField='GroupId' colorField='Color'>
                      </e-resource>
                  </e-resources>
              </ejs-schedule>
        </div>
    </div>
  </div>
</div>
</template>

<script>

import { KanbanComponent, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-vue-kanban';
import { extend, closest } from '@syncfusion/ej2-base';
import { kanbanData, scheduleData } from './datasource.js';

import { ScheduleComponent, TimelineViews, TimelineMonth, Resize, DragAndDrop, ViewDirective, ViewsDirective, ResourceDirective, ResourcesDirective } from "@syncfusion/ej2-vue-schedule";
import {createApp} from 'vue';

const app = createApp({});

var resourceHeaderVue = app.component("resource-headerTemplate", {
      data: () => ({}),
      template: '<div className="template-wrap"><div class="specialist-category"><div v-if=getConsultantImageName(data)></div><div class="specialist-name">' +
                '</div><div class="specialist-designation"></div></div></div>',
      methods: {
          getConsultantName: function (data) {
              let value = JSON.parse(JSON.stringify(data));
              return (value.resourceData) ? value.resourceData[value.resource.textField] : value.resourceName;
          },
          getConsultantImageName: function (data) {
              let value = JSON.parse(JSON.stringify(data));
              let resourceName = (value.resourceData) ? value.resourceData[value.resource.textField] : value.resourceName;
              if (resourceName === 'GENERAL' || resourceName === 'DENTAL') {
                  return false;
              } else {
                  return true;
              }
          },
          getConsultantDesignation: function (data) {
              let value = JSON.parse(JSON.stringify(data));
              var resourceName = value.resourceData[value.resource.textField];
              if (resourceName === "GENERAL" || resourceName === "DENTAL") {
                  return '';
              } else {
                  return value.resourceData.Designation;
              }
          }
      }
});

export default {
name: "App",
components: {
"ejs-kanban":KanbanComponent,
"e-columns":ColumnsDirective,
"e-column":ColumnDirective,
"ejs-schedule":ScheduleComponent,
"e-views":ViewsDirective,
"e-view":ViewDirective,
"e-resources":ResourcesDirective,
"e-resource":ResourceDirective
},
  data: function() {
    return {
      kanbanData: extend([], kanbanData, null, true),
      cardSettings: {
        contentField: "Name",
        headerField: "Id"
      },
      externalKanbanDropId: ['#schedule'],
      eventSettings: {
          dataSource: extend([], scheduleData, null, true),
          fields: {
              subject: { title: 'Patient Name', name: 'Name' },
              startTime: { title: "From", name: "StartTime" },
              endTime: { title: "To", name: "EndTime" },
              description: { title: 'Reason', name: 'Description' }
          },
      },
      selectedDate: new Date(2018, 7, 1),
      currentView: 'TimelineDay',
      cssClass: 'schedule-drag-drop',
      group: {
          enableCompactView: false,
          resources: ['Departments', 'Consultants']
      },
      departmentDataSource: [
          { Text: 'GENERAL', Id: 1, Color: '#bbdc00' },
          { Text: 'DENTAL', Id: 2, Color: '#9e5fff' }
      ],
      consultantDataSource: [
          { Text: 'Alice', Id: 1, GroupId: 1, Color: '#bbdc00', Designation: 'Cardiologist' },
          { Text: 'Nancy', Id: 2, GroupId: 2, Color: '#9e5fff', Designation: 'Orthodontist' },
          { Text: 'Robert', Id: 3, GroupId: 1, Color: '#bbdc00', Designation: 'Optometrist' },
          { Text: 'Robson', Id: 4, GroupId: 2, Color: '#9e5fff', Designation: 'Periodontist' },
          { Text: 'Laura', Id: 5, GroupId: 1, Color: '#bbdc00', Designation: 'Orthopedic' },
          { Text: 'Margaret', Id: 6, GroupId: 2, Color: '#9e5fff', Designation: 'Endodontist' }
      ],
      resourceHeaderTemplate: function () {
          return { template: resourceHeaderVue }
      }
    };
  },
  methods: {
     kanbanDragStop: function (args) {
        let scheduleElement = closest(args.event.target, '#schedule');
        let kanbanObj = this.$refs.kanbanObj.ej2Instances;
        let scheduleObj = this.$refs.scheduleObj.ej2Instances;
        if (scheduleElement) {
            kanbanObj.deleteCard(args.data);
            scheduleObj.openEditor(args.data[0], 'Add', true);
            args.cancel = true;
        }
      },
      onItemDragStop: function (args) {
        let kanbanElement = closest(args.event.target, '#kanban');
        let kanbanObj = this.$refs.kanbanObj.ej2Instances;
        let scheduleObj = this.$refs.scheduleObj.ej2Instances;
        if (kanbanElement) {
            scheduleObj.deleteEvent(args.data.Id);
             removeClass([scheduleObj.element.querySelector('.e-selected-cell')], 'e-selected-cell');
             kanbanObj.openDialog('Add', args.data);
             args.cancel = true;
        }
      }
   },
   provide: {
      schedule: [TimelineViews, TimelineMonth, Resize, DragAndDrop]
   }
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-layouts/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-calendars/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-excel-export/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-file-utils/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-schedule/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-compression/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-vue-kanban/styles/tailwind3.css';
.row {
  display: flex;
}
</style>

Syncfusion AI Assistant

How can I help you?

Drag and Drop in React Kanban Component

1 Dec 202524 minutes to read

All cards can be dragged and dropped across the columns or within the columns or swimlane row or kanban to an external source and vice versa.

The following drag and drop types are available in the Kanban board.

  • Internal drag and drop
    • Column drag and drop
    • Swimlane drag and drop
  • External drag and drop
    • Kanban to Kanban
    • Kanban to External source and vice versa.

Dropped card position varies based on the sortSettings property.

Internal drag and drop

Allows the user to drag and drop the cards within the kanban board. Based on this, we can categorize into two ways.

  • Column drag and drop
  • Swimlane drag and drop

Column drag and drop

By default, all cards can be dragged and dropped across the columns and within the columns. You cannot drag and drop the cards when disabling the allowDragAndDrop property.

You can prevent the drag or drop behavior of the particular column by disabling the allowDrag or allowDrop property.
You can also control the flow of transition cards between the columns by using the transitionColumns property.

In the following example, disable the drag and drop behavior on the Kanban board.

[Class-component]

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective } from "@syncfusion/ej2-react-kanban";
import { kanbanData } from './datasource';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.data = extend([], kanbanData, null, true);
    }
    render() {
        return <KanbanComponent id="kanban" keyField="Status" dataSource={this.data} cardSettings= allowDragAndDrop={false}>
                <ColumnsDirective>
                  <ColumnDirective headerText="To Do" keyField="Open"/>
                  <ColumnDirective headerText="In Progress" keyField="InProgress"/>
                  <ColumnDirective headerText="Testing" keyField="Testing"/>
                  <ColumnDirective headerText="Done" keyField="Close"/>
                </ColumnsDirective>
            </KanbanComponent>;
    }
}
;
ReactDOM.render(<App />, document.getElementById('kanban'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective } from "@syncfusion/ej2-react-kanban";
import { kanbanData } from './datasource';

class App extends React.Component<{}, {}>{
   constructor() {
        super(...arguments);
        this.data = extend([], kanbanData, null, true);
    }
  render() {
    return <KanbanComponent id="kanban" keyField="Status" dataSource={this.data} cardSettings= allowDragAndDrop={false}>
                <ColumnsDirective>
                  <ColumnDirective headerText="To Do" keyField="Open" />
                  <ColumnDirective headerText="In Progress" keyField="InProgress" />
                  <ColumnDirective headerText="Testing" keyField="Testing" />
                  <ColumnDirective headerText="Done" keyField="Close" />
                </ColumnsDirective>
            </KanbanComponent>
  }
};
ReactDOM.render(<App />, document.getElementById('kanban'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Kanban Cards</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Kanban Cards" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-layouts/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-dropdowns/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-kanban/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='kanban'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

[Functional-component]

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective } from "@syncfusion/ej2-react-kanban";
import { kanbanData } from './datasource';
function App() {
    let data = extend([], kanbanData, null, true);
    return (<KanbanComponent id="kanban" keyField="Status" dataSource={data} cardSettings= allowDragAndDrop={false}>
        <ColumnsDirective>
          <ColumnDirective headerText="To Do" keyField="Open"/>
          <ColumnDirective headerText="In Progress" keyField="InProgress"/>
          <ColumnDirective headerText="Testing" keyField="Testing"/>
          <ColumnDirective headerText="Done" keyField="Close"/>
        </ColumnsDirective>
    </KanbanComponent>);
}
ReactDOM.render(<App />, document.getElementById('kanban'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective } from "@syncfusion/ej2-react-kanban";
import { kanbanData } from './datasource';

function App(){
  let data = extend([], kanbanData, null, true);
  return(
    <KanbanComponent id="kanban" keyField="Status" dataSource={data} cardSettings= allowDragAndDrop={false}>
        <ColumnsDirective>
          <ColumnDirective headerText="To Do" keyField="Open" />
          <ColumnDirective headerText="In Progress" keyField="InProgress" />
          <ColumnDirective headerText="Testing" keyField="Testing" />
          <ColumnDirective headerText="Done" keyField="Close" />
        </ColumnsDirective>
    </KanbanComponent>
  );
}
ReactDOM.render(<App />, document.getElementById('kanban'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Kanban Cards</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Kanban Cards" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-layouts/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-dropdowns/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-kanban/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='kanban'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Swimlane drag and drop

By default, Swimlane allows drag and drop across the columns within the swimlane row. Kanban does not allow dragging the cards across the swimlane rows.

Enabling the dragAndDrop property allows you to drag the cards across the swimlane rows, which is specified inside the swimlaneSettings property.

[Class-component]

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective } from "@syncfusion/ej2-react-kanban";
import { kanbanData } from './datasource';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.data = extend([], kanbanData, null, true);
    }
    render() {
        return <KanbanComponent id="kanban" keyField="Status" dataSource={this.data} cardSettings= swimlaneSettings=>
                <ColumnsDirective>
                  <ColumnDirective headerText="To Do" keyField="Open"/>
                  <ColumnDirective headerText="In Progress" keyField="InProgress"/>
                  <ColumnDirective headerText="Testing" keyField="Testing"/>
                  <ColumnDirective headerText="Done" keyField="Close"/>
                </ColumnsDirective>
            </KanbanComponent>;
    }
}
;
ReactDOM.render(<App />, document.getElementById('kanban'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective } from "@syncfusion/ej2-react-kanban";
import { kanbanData } from './datasource';

class App extends React.Component<{}, {}>{
   constructor() {
        super(...arguments);
        this.data = extend([], kanbanData, null, true);
    }
  render() {
    return <KanbanComponent id="kanban" keyField="Status" dataSource={this.data} cardSettings= swimlaneSettings=>
                <ColumnsDirective>
                  <ColumnDirective headerText="To Do" keyField="Open" />
                  <ColumnDirective headerText="In Progress" keyField="InProgress" />
                  <ColumnDirective headerText="Testing" keyField="Testing" />
                  <ColumnDirective headerText="Done" keyField="Close" />
                </ColumnsDirective>
            </KanbanComponent>
  }
};
ReactDOM.render(<App />, document.getElementById('kanban'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Across Swimlane Drag and Drop</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Swimlane drag and drop" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-layouts/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-dropdowns/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-kanban/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='kanban'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

[Functional-component]

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective } from "@syncfusion/ej2-react-kanban";
import { kanbanData } from './datasource';
function App() {
    let data = extend([], kanbanData, null, true);
    return (<KanbanComponent id="kanban" keyField="Status" dataSource={data} cardSettings= swimlaneSettings=>
        <ColumnsDirective>
          <ColumnDirective headerText="To Do" keyField="Open"/>
          <ColumnDirective headerText="In Progress" keyField="InProgress"/>
          <ColumnDirective headerText="Testing" keyField="Testing"/>
          <ColumnDirective headerText="Done" keyField="Close"/>
        </ColumnsDirective>
    </KanbanComponent>);
}
ReactDOM.render(<App />, document.getElementById('kanban'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective } from "@syncfusion/ej2-react-kanban";
import { kanbanData } from './datasource';

function App(){
  let data = extend([], kanbanData, null, true);
  return(
    <KanbanComponent id="kanban" keyField="Status" dataSource={data} cardSettings= swimlaneSettings=>
        <ColumnsDirective>
          <ColumnDirective headerText="To Do" keyField="Open" />
          <ColumnDirective headerText="In Progress" keyField="InProgress" />
          <ColumnDirective headerText="Testing" keyField="Testing" />
          <ColumnDirective headerText="Done" keyField="Close" />
        </ColumnsDirective>
    </KanbanComponent>
  );
}
ReactDOM.render(<App />, document.getElementById('kanban'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Across Swimlane Drag and Drop</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Swimlane drag and drop" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-layouts/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-dropdowns/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-kanban/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='kanban'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

External drag and drop

Allows the user to drag and drop the cards from one kanban to another kanban or Kanban to an external source and vice versa.

Kanban to kanban

Drag and drop the card from one kanban to another kanban and vice versa. This can be achieved by specifying the externalDropId property which is used to specify the id of the dropped kanban element and the dragStop event which is used to delete the card on dragged Kanban and add the card on dropped Kanban using the deleteCard and addCard public methods.

Before adding a card to dropped kanban, you can manually change the card data headerField when the same card data headerField is dropped to another Kanban.

In the following example, Drag the card from one Kanban and drop it into another kanban using the dragStop event. In this event, remove the card from the dragged Kanban by using the deleteCard public method and add the card to the dropped Kanban by using the addCard public method.

[Class-component]

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend, closest } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective } from "@syncfusion/ej2-react-kanban";
import { kanbanAData, kanbanBData } from './datasource';
class App extends React.Component {
    kanbanA;
    kanbanB;
    constructor() {
        super(...arguments);
        this.dataA = extend([], kanbanAData, null, true);
        this.dataB = extend([], kanbanBData, null, true);
        this.externalKanbanADropId = ["#KanbanB"];
        this.externalKanbanBDropId = ["#KanbanA"];
    }
    onKanbanADragStop(args) {
        let kanbanBElement = closest(args.event.target, '#KanbanB');
        if (kanbanBElement) {
            this.kanbanA.deleteCard(args.data);
            args.data.forEach((card, i) => {
                const index = this.kanbanB.kanbanData.findIndex((colData) => colData[this.kanbanB.cardSettings.headerField] === card[this.kanbanB.cardSettings.headerField]);
                if (index !== -1) {
                    card[this.kanbanB.cardSettings.headerField] = Math.max(...this.kanbanB.kanbanData.map((obj) => parseInt(obj[this.kanbanB.cardSettings.headerField], 10))) + ++i;
                }
            });
            this.kanbanB.addCard(args.data, args.dropIndex);
            args.cancel = true;
        }
    }
    onKanbanBDragStop(args) {
        let kanbanAElement = closest(args.event.target, '#KanbanA');
        if (kanbanAElement) {
            this.kanbanB.deleteCard(args.data);
            args.data.forEach((card, i) => {
                const index = this.kanbanA.kanbanData.findIndex((colData) => colData[this.kanbanA.cardSettings.headerField] === card[this.kanbanA.cardSettings.headerField]);
                if (index !== -1) {
                    card[this.kanbanA.cardSettings.headerField] = Math.max(...this.kanbanA.kanbanData.map((obj) => parseInt(obj[this.kanbanA.cardSettings.headerField], 10))) + ++i;
                }
            });
            this.kanbanA.addCard(args.data, args.dropIndex);
            args.cancel = true;
        }
    }
    render() {
        return <div>
              <div className="container-fluid">
                  <div className="row">
                      <div className="col-sm-6">
                        <h4>Kanban A</h4>
                            <KanbanComponent id="KanbanA" ref={kanbanA => this.kanbanA = kanbanA} keyField="Status" dataSource={this.dataA} cardSettings= dragStop={this.onKanbanADragStop.bind(this)} externalDropId={this.externalKanbanADropId}>
                                <ColumnsDirective>
                                    <ColumnDirective headerText="To Do" keyField="Open"/>
                                    <ColumnDirective headerText="Done" keyField="Close"/>
                                </ColumnsDirective>
                            </KanbanComponent>
                      </div>
                      <div className="col-sm-6">
                          <h4>Kanban B</h4>
                            <KanbanComponent id="KanbanB" ref={kanbanB => this.kanbanB = kanbanB} keyField="Status" dataSource={this.dataB} cardSettings= dragStop={this.onKanbanBDragStop.bind(this)} externalDropId={this.externalKanbanBDropId}>
                                <ColumnsDirective>
                                    <ColumnDirective headerText="To Do" keyField="Open"/>
                                    <ColumnDirective headerText="Done" keyField="Close"/>
                                </ColumnsDirective>
                            </KanbanComponent>
                      </div>
                  </div>
              </div>
        </div>;
    }
}
;
ReactDOM.render(<App />, document.getElementById('kanban'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend, closest } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective, DragEventArgs, Kanban } from "@syncfusion/ej2-react-kanban";
import { kanbanAData, kanbanBData } from './datasource';

class App extends React.Component<{}, {}>{
  public kanbanA: Kanban | null;
  public kanbanB: Kanban | null;
   constructor() {
        super(...arguments);
        this.dataA = extend([], kanbanAData, null, true);
        this.dataB = extend([], kanbanBData, null, true);
        this.externalKanbanADropId = ["#KanbanB"];
        this.externalKanbanBDropId = ["#KanbanA"];
    }
    private onKanbanADragStop(args: DragEventArgs): void {
        let kanbanBElement: Element = closest(args.event.target as Element, '#KanbanB');
        if (kanbanBElement) {
          this.kanbanA.deleteCard(args.data);
          args.data.forEach((card: Record<string, any>, i: number) => {
              const index: number = this.kanbanB.kanbanData.findIndex((colData: Record<string, any>) =>
                  colData[this.kanbanB.cardSettings.headerField] === card[this.kanbanB.cardSettings.headerField]);
              if (index !== -1) {
                  card[this.kanbanB.cardSettings.headerField] = Math.max(...this.kanbanB.kanbanData.map(
                      (obj: Record<string, string>) => parseInt(obj[this.kanbanB.cardSettings.headerField], 10))) + ++i;
              }
          });
          this.kanbanB.addCard(args.data, args.dropIndex);
          args.cancel = true;
        }
    }
    private onKanbanBDragStop(args: DragEventArgs): void {
        let kanbanAElement: Element = closest(args.event.target as Element, '#KanbanA');
        if (kanbanAElement) {
          this.kanbanB.deleteCard(args.data);
          args.data.forEach((card: Record<string, any>, i: number) => {
              const index: number = this.kanbanA.kanbanData.findIndex((colData: Record<string, any>) =>
                  colData[this.kanbanA.cardSettings.headerField] === card[this.kanbanA.cardSettings.headerField]);
              if (index !== -1) {
                  card[this.kanbanA.cardSettings.headerField] = Math.max(...this.kanbanA.kanbanData.map(
                      (obj: Record<string, string>) => parseInt(obj[this.kanbanA.cardSettings.headerField], 10))) + ++i;
              }
          });
          this.kanbanA.addCard(args.data, args.dropIndex);
          args.cancel = true;
       }
  }
  render() {
    return <div>
              <div className="container-fluid">
                  <div className="row">
                      <div className="col-sm-6">
                        <h4>Kanban A</h4>
                            <KanbanComponent id="KanbanA" ref={kanbanA => this.kanbanA = kanbanA} keyField="Status" dataSource={this.dataA} cardSettings= dragStop={this.onKanbanADragStop.bind(this)} externalDropId={this.externalKanbanADropId}>
                                <ColumnsDirective>
                                    <ColumnDirective headerText="To Do" keyField="Open" />
                                    <ColumnDirective headerText="Done" keyField="Close" />
                                </ColumnsDirective>
                            </KanbanComponent>
                      </div>
                      <div className="col-sm-6">
                          <h4>Kanban B</h4>
                            <KanbanComponent id="KanbanB" ref={kanbanB => this.kanbanB = kanbanB} keyField="Status" dataSource={this.dataB} cardSettings= dragStop={this.onKanbanBDragStop.bind(this)} externalDropId={this.externalKanbanBDropId}>
                                <ColumnsDirective>
                                    <ColumnDirective headerText="To Do" keyField="Open" />
                                    <ColumnDirective headerText="Done" keyField="Close" />
                                </ColumnsDirective>
                            </KanbanComponent>
                      </div>
                  </div>
              </div>
        </div>
  }
};
ReactDOM.render(<App />, document.getElementById('kanban'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Kanban to Kanban drag and drop</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Kanban to Kanban drag and drop" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-layouts/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-dropdowns/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-kanban/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
        .row {
            display: flex;
        }
    </style>
</head>

<body>
        <div id='kanban'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

[Functional-component]

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend, closest } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective } from "@syncfusion/ej2-react-kanban";
import { kanbanAData, kanbanBData } from './datasource';
function App() {
    let kanbanA;
    let kanbanB;
    let dataA = extend([], kanbanAData, null, true);
    let dataB = extend([], kanbanBData, null, true);
    let externalKanbanADropId = ["#KanbanB"];
    let externalKanbanBDropId = ["#KanbanA"];
    function onKanbanADragStop(args) {
        let kanbanBElement = closest(args.event.target, '#KanbanB');
        if (kanbanBElement) {
            kanbanA.deleteCard(args.data);
            args.data.forEach((card, i) => {
                const index = kanbanB.kanbanData.findIndex((colData) => colData[kanbanB.cardSettings.headerField] === card[kanbanB.cardSettings.headerField]);
                if (index !== -1) {
                    card[kanbanB.cardSettings.headerField] = Math.max(...kanbanB.kanbanData.map((obj) => parseInt(obj[kanbanB.cardSettings.headerField], 10))) + ++i;
                }
            });
            kanbanB.addCard(args.data, args.dropIndex);
            args.cancel = true;
        }
    }
    function onKanbanBDragStop(args) {
        let kanbanAElement = closest(args.event.target, '#KanbanA');
        if (kanbanAElement) {
            kanbanB.deleteCard(args.data);
            args.data.forEach((card, i) => {
                const index = kanbanA.kanbanData.findIndex((colData) => colData[kanbanA.cardSettings.headerField] === card[kanbanA.cardSettings.headerField]);
                if (index !== -1) {
                    card[kanbanA.cardSettings.headerField] = Math.max(...kanbanA.kanbanData.map((obj) => parseInt(obj[kanbanA.cardSettings.headerField], 10))) + ++i;
                }
            });
            kanbanA.addCard(args.data, args.dropIndex);
            args.cancel = true;
        }
    }
    return (<div>
      <div className="container-fluid">
          <div className="row">
              <div className="col-sm-6">
                <h4>Kanban A</h4>
                    <KanbanComponent id="KanbanA" ref={kanbanA => kanbanA = kanbanA} keyField="Status" dataSource={dataA} cardSettings= dragStop={onKanbanADragStop.bind(this)} externalDropId={externalKanbanADropId}>
                        <ColumnsDirective>
                            <ColumnDirective headerText="To Do" keyField="Open"/>
                            <ColumnDirective headerText="Done" keyField="Close"/>
                        </ColumnsDirective>
                    </KanbanComponent>
              </div>
              <div className="col-sm-6">
                  <h4>Kanban B</h4>
                    <KanbanComponent id="KanbanB" ref={kanbanB => kanbanB = kanbanB} keyField="Status" dataSource={dataB} cardSettings= dragStop={onKanbanBDragStop.bind(this)} externalDropId={externalKanbanBDropId}>
                        <ColumnsDirective>
                            <ColumnDirective headerText="To Do" keyField="Open"/>
                            <ColumnDirective headerText="Done" keyField="Close"/>
                        </ColumnsDirective>
                    </KanbanComponent>
              </div>
          </div>
      </div>
    </div>);
}
ReactDOM.render(<App />, document.getElementById('kanban'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend, closest } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective, DragEventArgs, Kanban } from "@syncfusion/ej2-react-kanban";
import { kanbanAData, kanbanBData } from './datasource';

function App(){
  let kanbanA: Kanban | null;
  let kanbanB: Kanban | null;
  let dataA = extend([], kanbanAData, null, true);
  let dataB = extend([], kanbanBData, null, true);
  let externalKanbanADropId = ["#KanbanB"];
  let externalKanbanBDropId = ["#KanbanA"];
  function onKanbanADragStop(args: DragEventArgs): void {
    let kanbanBElement: Element = closest(args.event.target as Element, '#KanbanB');
    if (kanbanBElement) {
      kanbanA.deleteCard(args.data);
      args.data.forEach((card: Record<string, any>, i: number) => {
          const index: number = kanbanB.kanbanData.findIndex((colData: Record<string, any>) =>
              colData[kanbanB.cardSettings.headerField] === card[kanbanB.cardSettings.headerField]);
          if (index !== -1) {
              card[kanbanB.cardSettings.headerField] = Math.max(...kanbanB.kanbanData.map(
                  (obj: Record<string, string>) => parseInt(obj[kanbanB.cardSettings.headerField], 10))) + ++i;
          }
      });
      kanbanB.addCard(args.data, args.dropIndex);
      args.cancel = true;
    }
  }
  function onKanbanBDragStop(args: DragEventArgs): void {
      let kanbanAElement: Element = closest(args.event.target as Element, '#KanbanA');
      if (kanbanAElement) {
        kanbanB.deleteCard(args.data);
        args.data.forEach((card: Record<string, any>, i: number) => {
            const index: number = kanbanA.kanbanData.findIndex((colData: Record<string, any>) =>
                colData[kanbanA.cardSettings.headerField] === card[kanbanA.cardSettings.headerField]);
            if (index !== -1) {
                card[kanbanA.cardSettings.headerField] = Math.max(...kanbanA.kanbanData.map(
                    (obj: Record<string, string>) => parseInt(obj[kanbanA.cardSettings.headerField], 10))) + ++i;
            }
        });
        kanbanA.addCard(args.data, args.dropIndex);
        args.cancel = true;
      }
  }
  return(
    <div>
      <div className="container-fluid">
          <div className="row">
              <div className="col-sm-6">
                <h4>Kanban A</h4>
                    <KanbanComponent id="KanbanA" ref={kanbanA => kanbanA = kanbanA} keyField="Status" dataSource={dataA} cardSettings= dragStop={onKanbanADragStop.bind(this)} externalDropId={externalKanbanADropId}>
                        <ColumnsDirective>
                            <ColumnDirective headerText="To Do" keyField="Open" />
                            <ColumnDirective headerText="Done" keyField="Close" />
                        </ColumnsDirective>
                    </KanbanComponent>
              </div>
              <div className="col-sm-6">
                  <h4>Kanban B</h4>
                    <KanbanComponent id="KanbanB" ref={kanbanB => kanbanB = kanbanB} keyField="Status" dataSource={dataB} cardSettings= dragStop={onKanbanBDragStop.bind(this)} externalDropId={externalKanbanBDropId}>
                        <ColumnsDirective>
                            <ColumnDirective headerText="To Do" keyField="Open" />
                            <ColumnDirective headerText="Done" keyField="Close" />
                        </ColumnsDirective>
                    </KanbanComponent>
              </div>
          </div>
      </div>
    </div>
  );
}
ReactDOM.render(<App />, document.getElementById('kanban'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Kanban to Kanban drag and drop</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Kanban to Kanban drag and drop" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-layouts/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-dropdowns/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-kanban/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
        .row {
            display: flex;
        }
    </style>
</head>

<body>
        <div id='kanban'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Treeview to Kanban

Drag the card from the Kanban board and drop it to the Treeview component and vice versa.

In the following sample, remove the data from the Kanban board using the deleteCard public method and add to the Treeview component using the addNodes public method at Kanban dragStop event when dragging the card and dropping it to the Treeview component. Remove the data from Treeview using the removeNodes public method and add to Kanban board using the openDialog public method when dragging the list from the Treeview component and dropping it to the kanban board.

[Class-component]

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend, closest } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective } from "@syncfusion/ej2-react-kanban";
import { TreeViewComponent } from '@syncfusion/ej2-react-navigations';
import { kanbanData, treeViewData } from './datasource';
class App extends React.Component {
    kanbanObj;
    treeViewObj;
    constructor() {
        super(...arguments);
        this.data = extend([], kanbanData, null, true);
        this.treeData = extend([], treeViewData, null, true);
        this.fields = { dataSource: this.treeData, id: 'Id', text: 'Status' };
        this.allowDragAndDrops = true;
        this.externalKanbanDropId = ["#treeView"];
    }
    treeTemplate(props) {
        return (<div><div id="treelist"><div id="treeviewlist">{props.Id} - {props.Status}</div>
                </div></div>);
    }
    onKanbanADragStop(args) {
        let treeViewElement = closest(args.event.target, '#treeView');
        if (treeViewElement) {
            this.kanbanObj.deleteCard(args.data);
            this.treeViewObj.addNodes(args.data);
            args.cancel = true;
        }
    }
    onTreeDragStop(args) {
        let kanbanElement = closest(args.event.target, '#Kanban');
        if (kanbanElement) {
            let treeData = this.treeViewObj.fields.dataSource;
            const filteredData = treeData.filter((item) => item.Id === parseInt(args.draggedNodeData.id, 10));
            this.treeViewObj.removeNodes([args.draggedNodeData.id]);
            this.kanbanObj.openDialog('Add', filteredData[0]);
            args.cancel = true;
        }
    }
    render() {
        return <div>
          <div className="container-fluid">
                  <div className="row">
                      <div className="col-sm-6">
                        <h4>Kanban</h4>
                            <KanbanComponent id="Kanban" ref={kanban => this.kanbanObj = kanban} keyField="Status" dataSource={this.data} cardSettings= dragStop={this.onKanbanADragStop.bind(this)} externalDropId={this.externalKanbanDropId}>
                                <ColumnsDirective>
                                    <ColumnDirective headerText="To Do" keyField="Open"/>
                                    <ColumnDirective headerText="Done" keyField="Close"/>
                                </ColumnsDirective>
                            </KanbanComponent>
                      </div>
                    <div className="col-sm-6">
                    <h4>TreeView</h4>
                             <TreeViewComponent id="treeView" ref={treeView => this.treeViewObj = treeView} nodeTemplate={this.treeTemplate.bind(this)} fields={this.fields} nodeDragStop={this.onTreeDragStop.bind(this)} allowDragAndDrop={this.allowDragAndDrops}/>
                    </div>
                </div>
            </div>
        </div>;
    }
}
;
ReactDOM.render(<App />, document.getElementById('kanban'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend, closest } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective, DragEventArgs, Kanban } from "@syncfusion/ej2-react-kanban";
import { DragAndDropEventArgs } from '@syncfusion/ej2-navigations';
import { TreeViewComponent } from '@syncfusion/ej2-react-navigations';
import { kanbanData, treeViewData } from './datasource';

class App extends React.Component<{}, {}>{
  public kanbanObj: Kanban | null;
  public treeViewObj: TreeViewComponent | null;
   constructor() {
        super(...arguments);
        this.data = extend([], kanbanData, null, true);
        this.treeData = extend([], treeViewData, null, true);
        this.fields = { dataSource: this.treeData, id: 'Id', text: 'Status' };
        this.allowDragAndDrops = true;
        this.externalKanbanDropId = ["#treeView"];
    }
    private treeTemplate(props: KanbanDataModel): JSX.Element {
        return (<div><div id="treelist"><div id="treeviewlist">{props.Id} - {props.Status}</div>
                </div></div>);
    }
    private onKanbanADragStop(args: DragEventArgs): void {
       let treeViewElement: Element = closest(args.event.target as Element, '#treeView');
          if (treeViewElement) {
              this.kanbanObj.deleteCard(args.data);
              this.treeViewObj.addNodes(args.data);
              args.cancel = true;
          }
    }
    private onTreeDragStop(args: DragAndDropEventArgs): void {
      let kanbanElement: Element = closest(args.event.target as Element, '#Kanban');
          if (kanbanElement) {
              let treeData = this.treeViewObj.fields.dataSource as { [key: string]: Object }[];
              const filteredData =
                  treeData.filter((item: any) => item.Id === parseInt(args.draggedNodeData.id as string, 10));
              this.treeViewObj.removeNodes([args.draggedNodeData.id] as string[]);
              this.kanbanObj.openDialog('Add', filteredData[0]);
              args.cancel = true;
          }
    }
  render() {
    return <div>
          <div className="container-fluid">
                  <div className="row">
                      <div className="col-sm-6">
                        <h4>Kanban</h4>
                            <KanbanComponent id="Kanban" ref={kanban => this.kanbanObj = kanban} keyField="Status" dataSource={this.data} cardSettings= dragStop={this.onKanbanADragStop.bind(this)} externalDropId={this.externalKanbanDropId} >
                                <ColumnsDirective>
                                    <ColumnDirective headerText="To Do" keyField="Open" />
                                    <ColumnDirective headerText="Done" keyField="Close" />
                                </ColumnsDirective>
                            </KanbanComponent>
                      </div>
                    <div className="col-sm-6">
                    <h4>TreeView</h4>
                             <TreeViewComponent id="treeView" ref={treeView => this.treeViewObj = treeView} nodeTemplate={this.treeTemplate.bind(this)} fields={this.fields} nodeDragStop={this.onTreeDragStop.bind(this)} allowDragAndDrop={this.allowDragAndDrops} />
                    </div>
                </div>
            </div>
        </div>
  }
};
ReactDOM.render(<App />, document.getElementById('kanban'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Kanban to treeview drag and drop</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Kanban to treeview drag and drop" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-layouts/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-dropdowns/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-kanban/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
        .row {
            display: flex;
        }
    </style>
</head>

<body>
        <div id='kanban'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

[Functional-component]

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend, closest } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective } from "@syncfusion/ej2-react-kanban";
import { TreeViewComponent } from '@syncfusion/ej2-react-navigations';
import { kanbanData, treeViewData } from './datasource';
function App() {
    let kanbanObj;
    let treeViewObj;
    let data = extend([], kanbanData, null, true);
    let treeData = extend([], treeViewData, null, true);
    let fields = { dataSource: treeData, id: 'Id', text: 'Status' };
    let allowDragAndDrops = true;
    let externalKanbanDropId = ["#treeView"];
    function treeTemplate(props) {
        return (<div><div id="treelist"><div id="treeviewlist">{props.Id} - {props.Status}</div></div></div>);
    }
    function onKanbanADragStop(args) {
        let treeViewElement = closest(args.event.target, '#treeView');
        if (treeViewElement) {
            kanbanObj.deleteCard(args.data);
            treeViewObj.addNodes(args.data);
            args.cancel = true;
        }
    }
    function onTreeDragStop(args) {
        let kanbanElement = closest(args.event.target, '#Kanban');
        if (kanbanElement) {
            let treeData = treeViewObj.fields.dataSource;
            const filteredData = treeData.filter((item) => item.Id === parseInt(args.draggedNodeData.id, 10));
            treeViewObj.removeNodes([args.draggedNodeData.id]);
            kanbanObj.openDialog('Add', filteredData[0]);
            args.cancel = true;
        }
    }
    return (<div>
      <div className="container-fluid">
        <div className="row">
            <div className="col-sm-6">
              <h4>Kanban</h4>
                  <KanbanComponent id="Kanban" ref={kanban => kanbanObj = kanban} keyField="Status" dataSource={data} cardSettings= dragStop={onKanbanADragStop.bind(this)} externalDropId={externalKanbanDropId}>
                      <ColumnsDirective>
                          <ColumnDirective headerText="To Do" keyField="Open"/>
                          <ColumnDirective headerText="Done" keyField="Close"/>
                      </ColumnsDirective>
                  </KanbanComponent>
            </div>
            <div className="col-sm-6">
              <h4>TreeView</h4>
                <TreeViewComponent id="treeView" ref={treeView => treeViewObj = treeView} nodeTemplate={treeTemplate.bind(this)} fields={fields} nodeDragStop={onTreeDragStop.bind(this)} allowDragAndDrop={allowDragAndDrops}/>
            </div>
        </div>
      </div>
    </div>);
}
ReactDOM.render(<App />, document.getElementById('kanban'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend, closest } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective, DragEventArgs, Kanban } from "@syncfusion/ej2-react-kanban";
import { DragAndDropEventArgs } from '@syncfusion/ej2-navigations';
import { TreeViewComponent } from '@syncfusion/ej2-react-navigations';
import { kanbanData, treeViewData } from './datasource';

function App(){
  let kanbanObj: Kanban | null;
  let treeViewObj: TreeViewComponent | null;
  let data = extend([], kanbanData, null, true);
  let treeData = extend([], treeViewData, null, true);
  let fields = { dataSource: treeData, id: 'Id', text: 'Status' };
  let allowDragAndDrops = true;
  let externalKanbanDropId = ["#treeView"];

  function treeTemplate(props: KanbanDataModel): JSX.Element {
      return (<div><div id="treelist"><div id="treeviewlist">{props.Id} - {props.Status}</div></div></div>);
  }
  function onKanbanADragStop(args: DragEventArgs): void {
      let treeViewElement: Element = closest(args.event.target as Element, '#treeView');
        if (treeViewElement) {
            kanbanObj.deleteCard(args.data);
            treeViewObj.addNodes(args.data);
            args.cancel = true;
        }
  }
  function onTreeDragStop(args: DragAndDropEventArgs): void {
    let kanbanElement: Element = closest(args.event.target as Element, '#Kanban');
        if (kanbanElement) {
            let treeData = treeViewObj.fields.dataSource as { [key: string]: Object }[];
            const filteredData =
                treeData.filter((item: any) => item.Id === parseInt(args.draggedNodeData.id as string, 10));
            treeViewObj.removeNodes([args.draggedNodeData.id] as string[]);
            kanbanObj.openDialog('Add', filteredData[0]);
            args.cancel = true;
        }
  }
  return(
    <div>
      <div className="container-fluid">
        <div className="row">
            <div className="col-sm-6">
              <h4>Kanban</h4>
                  <KanbanComponent id="Kanban" ref={kanban => kanbanObj = kanban} keyField="Status" dataSource={data} cardSettings= dragStop={onKanbanADragStop.bind(this)} externalDropId={externalKanbanDropId} >
                      <ColumnsDirective>
                          <ColumnDirective headerText="To Do" keyField="Open" />
                          <ColumnDirective headerText="Done" keyField="Close" />
                      </ColumnsDirective>
                  </KanbanComponent>
            </div>
            <div className="col-sm-6">
              <h4>TreeView</h4>
                <TreeViewComponent id="treeView" ref={treeView => treeViewObj = treeView} nodeTemplate={treeTemplate.bind(this)} fields={fields} nodeDragStop={onTreeDragStop.bind(this)} allowDragAndDrop={allowDragAndDrops} />
            </div>
        </div>
      </div>
    </div>
  );
}
ReactDOM.render(<App />, document.getElementById('kanban'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Kanban to treeview drag and drop</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Kanban to treeview drag and drop" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-layouts/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-dropdowns/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-kanban/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
        .row {
            display: flex;
        }
    </style>
</head>

<body>
        <div id='kanban'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Schedule to Kanban

Drag the card from the Kanban board and drop it to the Schedule component and vice versa.

In the following sample, remove the data from the Kanban board using the deleteCard public method and add to the schedule component using the addNodes public method at Kanban dragStop event when dragging the card and dropping it to the Treeview component. Remove the data from Treeview using the removeNodes public method and add to Kanban board using the addCard public method when dragging the list from the Treeview component and dropping it to the kanban board.

[Class-component]

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend, closest, removeClass } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective } from "@syncfusion/ej2-react-kanban";
import { ScheduleComponent, ResourcesDirective, ResourceDirective, ViewsDirective, ViewDirective, Inject, TimelineViews, Resize, DragAndDrop, TimelineMonth } from '@syncfusion/ej2-react-schedule';
import { kanbanData, scheduleData } from './datasource';
class App extends React.Component {
    kanbanObj;
    scheduleObj;
    constructor() {
        super(...arguments);
        this.data = extend([], kanbanData, null, true);
        this.scheduleDataSource = extend([], scheduleData, null, true);
        this.externalKanbanDropId = ["#Schedule"];
    }
    departmentData = [
        { Text: 'GENERAL', Id: 1, Color: '#bbdc00' },
        { Text: 'DENTAL', Id: 2, Color: '#9e5fff' }
    ];
    consultantData = [
        { Text: 'Alice', Id: 1, GroupId: 1, Color: '#bbdc00', Designation: 'Cardiologist' },
        { Text: 'Nancy', Id: 2, GroupId: 2, Color: '#9e5fff', Designation: 'Orthodontist' },
        { Text: 'Robert', Id: 3, GroupId: 1, Color: '#bbdc00', Designation: 'Optometrist' },
        { Text: 'Robson', Id: 4, GroupId: 2, Color: '#9e5fff', Designation: 'Periodontist' },
        { Text: 'Laura', Id: 5, GroupId: 1, Color: '#bbdc00', Designation: 'Orthopedic' },
        { Text: 'Margaret', Id: 6, GroupId: 2, Color: '#9e5fff', Designation: 'Endodontist' }
    ];
    getConsultantName(value) {
        return value.resourceData[value.resource.textField];
    }
    getConsultantDesignation(value) {
        return value.resourceData.Designation;
    }
    resourceHeaderTemplate(props) {
        return (<div className="template-wrap"><div className="specialist-category"><div className="specialist-name">
        {this.getConsultantName(props)}</div><div className="specialist-designation">{this.getConsultantDesignation(props)}</div></div></div>);
    }
    onKanbanDragStop(args) {
        let scheduleElement = closest(args.event.target, '#Schedule');
        if (scheduleElement) {
            this.kanbanObj.deleteCard(args.data);
            this.scheduleObj.openEditor(args.data[0], 'Add', true);
            args.cancel = true;
        }
    }
    scheduleDragStop(args) {
        let kanbanElement = closest(args.event.target, '#Kanban');
        if (kanbanElement) {
            this.scheduleObj.deleteEvent(args.data.Id);
            removeClass([this.scheduleObj.element.querySelector('.e-selected-cell')], 'e-selected-cell');
            this.kanbanObj.openDialog('Add', args.data);
            args.cancel = true;
        }
    }
    render() {
        return <div>
          <div className="container-fluid">
                  <div className="row">
                      <div className="col-sm-6">
                        <h4>Kanban</h4>
                            <KanbanComponent id="Kanban" ref={kanban => this.kanbanObj = kanban} keyField="DepartmentName" dataSource={this.data} cardSettings={{ contentField: "Name", headerField: "Id" }} dragStop={this.onKanbanDragStop.bind(this)} externalDropId={this.externalKanbanDropId}>
                                <ColumnsDirective>
                                    <ColumnDirective headerText="GENERAL" keyField="GENERAL"/>
                                </ColumnsDirective>
                            </KanbanComponent>
                      </div>
                    <div className="col-sm-6">
                    <h4>Schedule</h4>
                          <ScheduleComponent id="Schedule" ref={schedule => this.scheduleObj = schedule} cssClass='schedule-drag-drop' width='100%' height='650px' selectedDate={new Date(2018, 7, 1)} currentView='TimelineDay' resourceHeaderTemplate={this.resourceHeaderTemplate.bind(this)} eventSettings={{
                dataSource: this.scheduleDataSource,
                fields: {
                    subject: { title: 'Patient Name', name: 'Name' },
                    startTime: { title: "From", name: "StartTime" },
                    endTime: { title: "To", name: "EndTime" },
                    description: { title: 'Reason', name: 'Description' }
                }
            }} group={{ enableCompactView: false, resources: ['Departments', 'Consultants'] }} dragStop={this.scheduleDragStop.bind(this)}>
                                  <ResourcesDirective>
                                    <ResourceDirective field='DepartmentID' title='Department' name='Departments' allowMultiple={false} dataSource={this.departmentData} textField='Text' idField='Id' colorField='Color'>
                                    </ResourceDirective>
                                    <ResourceDirective field='ConsultantID' title='Consultant' name='Consultants' allowMultiple={false} dataSource={this.consultantData} textField='Text' idField='Id' groupIDField="GroupId" colorField='Color'>
                                    </ResourceDirective>
                                  </ResourcesDirective>
                                  <ViewsDirective>
                                    <ViewDirective option='TimelineDay'/>
                                    <ViewDirective option='TimelineMonth'/>
                                  </ViewsDirective>
                                  <Inject services={[TimelineViews, TimelineMonth, Resize, DragAndDrop]}/>
                          </ScheduleComponent>
                    </div>
                </div>
            </div>
        </div>;
    }
}
;
ReactDOM.render(<App />, document.getElementById('kanban'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend, closest, removeClass } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective, DragEventArgs, Kanban } from "@syncfusion/ej2-react-kanban";
import {
  ScheduleComponent, ResourcesDirective, ResourceDirective,
  ViewsDirective, ViewDirective, Inject, TimelineViews,
  Resize, DragAndDrop, TimelineMonth
} from '@syncfusion/ej2-react-schedule';
import { kanbanData, scheduleData } from './datasource';

class App extends React.Component<{}, {}>{
  public kanbanObj: Kanban | null;
  public scheduleObj: ScheduleComponent | null;
   constructor() {
        super(...arguments);
        this.data = extend([], kanbanData, null, true);
        this.scheduleDataSource = extend([], scheduleData, null, true);
        this.externalKanbanDropId = ["#Schedule"];
    }
    private departmentData: Object[] = [
      { Text: 'GENERAL', Id: 1, Color: '#bbdc00' },
      { Text: 'DENTAL', Id: 2, Color: '#9e5fff' }
    ];
    private consultantData: Object[] = [
      { Text: 'Alice', Id: 1, GroupId: 1, Color: '#bbdc00', Designation: 'Cardiologist' },
      { Text: 'Nancy', Id: 2, GroupId: 2, Color: '#9e5fff', Designation: 'Orthodontist' },
      { Text: 'Robert', Id: 3, GroupId: 1, Color: '#bbdc00', Designation: 'Optometrist' },
      { Text: 'Robson', Id: 4, GroupId: 2, Color: '#9e5fff', Designation: 'Periodontist' },
      { Text: 'Laura', Id: 5, GroupId: 1, Color: '#bbdc00', Designation: 'Orthopedic' },
      { Text: 'Margaret', Id: 6, GroupId: 2, Color: '#9e5fff', Designation: 'Endodontist' }
    ];
    private getConsultantName(value: ResourceDetails | TreeViewArgs): string {
      return (value as ResourceDetails).resourceData[(value as ResourceDetails).resource.textField] as string;
    }

    private getConsultantDesignation(value: ResourceDetails): string {
      return (value as ResourceDetails).resourceData.Designation as string;
    }

    private resourceHeaderTemplate(props: any): JSX.Element {
      return (<div className="template-wrap"><div className="specialist-category"><div className="specialist-name">
        {this.getConsultantName(props)}</div><div className="specialist-designation">{this.getConsultantDesignation(props)}</div></div></div>);
    }
    private onKanbanDragStop(args: DragEventArgs): void {
       let scheduleElement: Element = closest(args.event.target as Element, '#Schedule');
        if (scheduleElement) {
            this.kanbanObj.deleteCard(args.data);
            this.scheduleObj.openEditor(args.data[0], 'Add', true);
            args.cancel = true;
        }
    }
    private scheduleDragStop(args: ScheduleDragEventArgs): void {
        let kanbanElement: Element = closest(args.event.target as Element, '#Kanban');
        if (kanbanElement) {
             this.scheduleObj.deleteEvent(args.data.Id);
             removeClass([this.scheduleObj.element.querySelector('.e-selected-cell')], 'e-selected-cell');
             this.kanbanObj.openDialog('Add', args.data);
             args.cancel = true;
        }
    }
  render() {
    return <div>
          <div className="container-fluid">
                  <div className="row">
                      <div className="col-sm-6">
                        <h4>Kanban</h4>
                            <KanbanComponent id="Kanban" ref={kanban => this.kanbanObj = kanban} keyField="DepartmentName" dataSource={this.data} cardSettings={{ contentField: "Name", headerField: "Id" }} dragStop={this.onKanbanDragStop.bind(this)} externalDropId={this.externalKanbanDropId}>
                                <ColumnsDirective>
                                    <ColumnDirective headerText="GENERAL" keyField="GENERAL" />
                                </ColumnsDirective>
                            </KanbanComponent>
                      </div>
                    <div className="col-sm-6">
                    <h4>Schedule</h4>
                          <ScheduleComponent id="Schedule" ref={schedule => this.scheduleObj = schedule} cssClass='schedule-drag-drop' width='100%' height='650px' selectedDate={new Date(2018, 7, 1)}
                              currentView='TimelineDay' resourceHeaderTemplate={this.resourceHeaderTemplate.bind(this)}
                                  eventSettings={{
                                    dataSource: this.scheduleDataSource,
                                    fields: {
                                      subject: { title: 'Patient Name', name: 'Name' },
                                      startTime: { title: "From", name: "StartTime" },
                                      endTime: { title: "To", name: "EndTime" },
                                      description: { title: 'Reason', name: 'Description' }
                                    }
                                  }}
                                  group={{ enableCompactView: false, resources: ['Departments', 'Consultants'] }}
                                  dragStop={this.scheduleDragStop.bind(this)} >
                                  <ResourcesDirective>
                                    <ResourceDirective field='DepartmentID' title='Department' name='Departments' allowMultiple={false}
                                      dataSource={this.departmentData} textField='Text' idField='Id' colorField='Color'>
                                    </ResourceDirective>
                                    <ResourceDirective field='ConsultantID' title='Consultant' name='Consultants' allowMultiple={false}
                                      dataSource={this.consultantData} textField='Text' idField='Id' groupIDField="GroupId" colorField='Color'>
                                    </ResourceDirective>
                                  </ResourcesDirective>
                                  <ViewsDirective>
                                    <ViewDirective option='TimelineDay' />
                                    <ViewDirective option='TimelineMonth' />
                                  </ViewsDirective>
                                  <Inject services={[TimelineViews, TimelineMonth, Resize, DragAndDrop]} />
                          </ScheduleComponent>
                    </div>
                </div>
            </div>
        </div>
  }
};
ReactDOM.render(<App />, document.getElementById('kanban'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Kanban to schedule drag and drop</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Kanban to schedule drag and drop" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-layouts/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-dropdowns/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-kanban/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-calendars/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-excel-export/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-file-utils/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-schedule/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-compression/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
        .row {
            display: flex;
        }
    </style>
</head>

<body>
        <div id='kanban'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

[Functional-component]

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend, closest, removeClass } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective } from "@syncfusion/ej2-react-kanban";
import { ScheduleComponent, ResourcesDirective, ResourceDirective, ViewsDirective, ViewDirective, Inject, TimelineViews, Resize, DragAndDrop, TimelineMonth } from '@syncfusion/ej2-react-schedule';
import { kanbanData, scheduleData } from './datasource';
function App() {
    let kanbanObj;
    let scheduleObj;
    let data = extend([], kanbanData, null, true);
    let scheduleDataSource = extend([], scheduleData, null, true);
    let externalKanbanDropId = ["#Schedule"];
    let departmentData = [
        { Text: 'GENERAL', Id: 1, Color: '#bbdc00' },
        { Text: 'DENTAL', Id: 2, Color: '#9e5fff' }
    ];
    let consultantData = [
        { Text: 'Alice', Id: 1, GroupId: 1, Color: '#bbdc00', Designation: 'Cardiologist' },
        { Text: 'Nancy', Id: 2, GroupId: 2, Color: '#9e5fff', Designation: 'Orthodontist' },
        { Text: 'Robert', Id: 3, GroupId: 1, Color: '#bbdc00', Designation: 'Optometrist' },
        { Text: 'Robson', Id: 4, GroupId: 2, Color: '#9e5fff', Designation: 'Periodontist' },
        { Text: 'Laura', Id: 5, GroupId: 1, Color: '#bbdc00', Designation: 'Orthopedic' },
        { Text: 'Margaret', Id: 6, GroupId: 2, Color: '#9e5fff', Designation: 'Endodontist' }
    ];
    function getConsultantName(value) {
        return value.resourceData[value.resource.textField];
    }
    function getConsultantDesignation(value) {
        return value.resourceData.Designation;
    }
    function resourceHeaderTemplate(props) {
        return (<div className="template-wrap"><div className="specialist-category"><div className="specialist-name">
      {getConsultantName(props)}</div><div className="specialist-designation">{getConsultantDesignation(props)}</div></div></div>);
    }
    function onKanbanDragStop(args) {
        let scheduleElement = closest(args.event.target, '#Schedule');
        if (scheduleElement) {
            kanbanObj.deleteCard(args.data);
            scheduleObj.openEditor(args.data[0], 'Add', true);
            args.cancel = true;
        }
    }
    function scheduleDragStop(args) {
        let kanbanElement = closest(args.event.target, '#Kanban');
        if (kanbanElement) {
            scheduleObj.deleteEvent(args.data.Id);
            removeClass([scheduleObj.element.querySelector('.e-selected-cell')], 'e-selected-cell');
            kanbanObj.openDialog('Add', args.data);
            args.cancel = true;
        }
    }
    return (<div>
        <div className="container-fluid">
          <div className="row">
            <div className="col-sm-6">
              <h4>Kanban</h4>
                  <KanbanComponent id="Kanban" ref={kanban => kanbanObj = kanban} keyField="DepartmentName" dataSource={data} cardSettings={{ contentField: "Name", headerField: "Id" }} dragStop={onKanbanDragStop.bind(this)} externalDropId={externalKanbanDropId}>
                      <ColumnsDirective>
                          <ColumnDirective headerText="GENERAL" keyField="GENERAL"/>
                      </ColumnsDirective>
                  </KanbanComponent>
            </div>
            <div className="col-sm-6">
              <h4>Schedule</h4>
              <ScheduleComponent id="Schedule" ref={schedule => scheduleObj = schedule} cssClass='schedule-drag-drop' width='100%' height='650px' selectedDate={new Date(2018, 7, 1)} currentView='TimelineDay' resourceHeaderTemplate={resourceHeaderTemplate.bind(this)} eventSettings={{
            dataSource: scheduleDataSource,
            fields: {
                subject: { title: 'Patient Name', name: 'Name' },
                startTime: { title: "From", name: "StartTime" },
                endTime: { title: "To", name: "EndTime" },
                description: { title: 'Reason', name: 'Description' }
            }
        }} group={{ enableCompactView: false, resources: ['Departments', 'Consultants'] }} dragStop={scheduleDragStop.bind(this)}>
                      <ResourcesDirective>
                        <ResourceDirective field='DepartmentID' title='Department' name='Departments' allowMultiple={false} dataSource={departmentData} textField='Text' idField='Id' colorField='Color'>
                        </ResourceDirective>
                        <ResourceDirective field='ConsultantID' title='Consultant' name='Consultants' allowMultiple={false} dataSource={consultantData} textField='Text' idField='Id' groupIDField="GroupId" colorField='Color'>
                        </ResourceDirective>
                      </ResourcesDirective>
                      <ViewsDirective>
                        <ViewDirective option='TimelineDay'/>
                        <ViewDirective option='TimelineMonth'/>
                      </ViewsDirective>
                      <Inject services={[TimelineViews, TimelineMonth, Resize, DragAndDrop]}/>
              </ScheduleComponent>
            </div>
          </div>
        </div>
      </div>);
}
ReactDOM.render(<App />, document.getElementById('kanban'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { extend, closest, removeClass } from '@syncfusion/ej2-base';
import { KanbanComponent, ColumnsDirective, ColumnDirective, DragEventArgs, Kanban } from "@syncfusion/ej2-react-kanban";
import {
  ScheduleComponent, ResourcesDirective, ResourceDirective,
  ViewsDirective, ViewDirective, Inject, TimelineViews,
  Resize, DragAndDrop, TimelineMonth
} from '@syncfusion/ej2-react-schedule';
import { kanbanData, scheduleData } from './datasource';

function App(){
    let kanbanObj: Kanban | null;
    let scheduleObj: ScheduleComponent | null;
    let data = extend([], kanbanData, null, true);
    let scheduleDataSource = extend([], scheduleData, null, true);
    let externalKanbanDropId = ["#Schedule"];
    let departmentData: Object[] = [
        { Text: 'GENERAL', Id: 1, Color: '#bbdc00' },
        { Text: 'DENTAL', Id: 2, Color: '#9e5fff' }
      ];
    let consultantData: Object[] = [
        { Text: 'Alice', Id: 1, GroupId: 1, Color: '#bbdc00', Designation: 'Cardiologist' },
        { Text: 'Nancy', Id: 2, GroupId: 2, Color: '#9e5fff', Designation: 'Orthodontist' },
        { Text: 'Robert', Id: 3, GroupId: 1, Color: '#bbdc00', Designation: 'Optometrist' },
        { Text: 'Robson', Id: 4, GroupId: 2, Color: '#9e5fff', Designation: 'Periodontist' },
        { Text: 'Laura', Id: 5, GroupId: 1, Color: '#bbdc00', Designation: 'Orthopedic' },
        { Text: 'Margaret', Id: 6, GroupId: 2, Color: '#9e5fff', Designation: 'Endodontist' }
      ];
    function getConsultantName(value: ResourceDetails | TreeViewArgs): string {
      return (value as ResourceDetails).resourceData[(value as ResourceDetails).resource.textField] as string;
    }
    function getConsultantDesignation(value: ResourceDetails): string {
      return (value as ResourceDetails).resourceData.Designation as string;
    }

    function resourceHeaderTemplate(props: any): JSX.Element {
      return (<div className="template-wrap"><div className="specialist-category"><div className="specialist-name">
      {getConsultantName(props)}</div><div className="specialist-designation">{getConsultantDesignation(props)}</div></div></div>);
    }
    function onKanbanDragStop(args: DragEventArgs): void {
      let scheduleElement: Element = closest(args.event.target as Element, '#Schedule');
        if (scheduleElement) {
            kanbanObj.deleteCard(args.data);
            scheduleObj.openEditor(args.data[0], 'Add', true);
            args.cancel = true;
        }
    }
    function scheduleDragStop(args: ScheduleDragEventArgs): void {
      let kanbanElement: Element = closest(args.event.target as Element, '#Kanban');
      if (kanbanElement) {
          scheduleObj.deleteEvent(args.data.Id);
          removeClass([scheduleObj.element.querySelector('.e-selected-cell')], 'e-selected-cell');
          kanbanObj.openDialog('Add', args.data);
          args.cancel = true;
      }
    }
    return (
      <div>
        <div className="container-fluid">
          <div className="row">
            <div className="col-sm-6">
              <h4>Kanban</h4>
                  <KanbanComponent id="Kanban" ref={kanban => kanbanObj = kanban} keyField="DepartmentName" dataSource={data} cardSettings={{ contentField: "Name", headerField: "Id" }} dragStop={onKanbanDragStop.bind(this)} externalDropId={externalKanbanDropId}>
                      <ColumnsDirective>
                          <ColumnDirective headerText="GENERAL" keyField="GENERAL" />
                      </ColumnsDirective>
                  </KanbanComponent>
            </div>
            <div className="col-sm-6">
              <h4>Schedule</h4>
              <ScheduleComponent id="Schedule" ref={schedule => scheduleObj = schedule} cssClass='schedule-drag-drop' width='100%' height='650px' selectedDate={new Date(2018, 7, 1)}
                  currentView='TimelineDay' resourceHeaderTemplate={resourceHeaderTemplate.bind(this)}
                      eventSettings={{
                        dataSource: scheduleDataSource,
                        fields: {
                          subject: { title: 'Patient Name', name: 'Name' },
                          startTime: { title: "From", name: "StartTime" },
                          endTime: { title: "To", name: "EndTime" },
                          description: { title: 'Reason', name: 'Description' }
                        }
                      }}
                      group={{ enableCompactView: false, resources: ['Departments', 'Consultants'] }}
                      dragStop={scheduleDragStop.bind(this)} >
                      <ResourcesDirective>
                        <ResourceDirective field='DepartmentID' title='Department' name='Departments' allowMultiple={false}
                          dataSource={departmentData} textField='Text' idField='Id' colorField='Color'>
                        </ResourceDirective>
                        <ResourceDirective field='ConsultantID' title='Consultant' name='Consultants' allowMultiple={false}
                          dataSource={consultantData} textField='Text' idField='Id' groupIDField="GroupId" colorField='Color'>
                        </ResourceDirective>
                      </ResourcesDirective>
                      <ViewsDirective>
                        <ViewDirective option='TimelineDay' />
                        <ViewDirective option='TimelineMonth' />
                      </ViewsDirective>
                      <Inject services={[TimelineViews, TimelineMonth, Resize, DragAndDrop]} />
              </ScheduleComponent>
            </div>
          </div>
        </div>
      </div>
    );
}
ReactDOM.render(<App />, document.getElementById('kanban'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Kanban to schedule drag and drop</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Kanban to schedule drag and drop" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-layouts/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-dropdowns/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-kanban/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-calendars/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-excel-export/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-file-utils/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-schedule/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-react-compression/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
        .row {
            display: flex;
        }
    </style>
</head>

<body>
        <div id='kanban'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>